<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_Login extends Controller_Containers_Admin {
	
    public function action_login()
    {
        if($this->current_user)
            Request::current()->redirect('admin/');
			
        Session::instance()->delete('current_user');
        $view = View::factory('admin/login/login');

        if (!empty($_POST))
        {
            $user = Model_User::authenticate($_POST['username'], $_POST['password']);

            if ($user && $this->login($user->id)) 
            {

                $this->request->redirect('/admin/');
            }
        }
             
        $this->template->content = $view;
    }
    
    protected function login($user_id)
    {
        $user = ORM::factory("User", $user_id);
        if (!$user->loaded())
            return false;

        $this->session->set('user_id', $user->id);
        return true;
    }
    
    public function action_logout()
    {
        $this->logout();
        $this->request->redirect('/admin/');
    }
	
    
	
    public function action_forgot_password()
    {
        if($this->current_user)
        {
            $this->request->redirect('/');
        }
        
        if(count($_POST))
        {
            $user = ORM::factory('User')->
                where('email', '=', $_POST['email'])->find();
            
            
            if (!$user->loaded())
            {
                FlashMessenger::factory()->
                        set_message('error', 'El Email ingresado no consta en el sistema.');
            }
            elseif ($user->status != 'ACTIVE')
            {
                FlashMessenger::factory()->
                        set_message('error', 'Tu cuenta no esta activa.');
            }
            else
            {
                // create our password reset token, valid for 24 hours
                $expiration = date_create('+24 hours');

                $token = ORM::factory('AuthToken');
                $token->type = 'reset_password';
                $token->user_id = $user->id;
                $token->expiration_date = $expiration->format('Y-m-d H:i:s');
                $token->save();
				
                $mail_view = View::factory('admin/account/email/forgot_password');
                $mail_view->reset_url = Kohana::$config->load('site.url').'admin/account/new_password/'.$token->token;

                // Send password reset confirmation
                $swift = Email::connect();		
                //Create the message
                $message = Swift_Message::newInstance()
                        ->setSubject('Por favor verifica el Email para tu cuenta de '.Kohana::$config->load('site.name'))
                        ->setFrom( array(Kohana::$config->load('site.email') => Kohana::$config->load('site.name') ))
                        ->setTo($user->email)
                        ->setBody('OSCUS')
                        ->addPart($mail_view->render(), 'text/html');

                $swift->send($message);

                $view = View::factory('admin/login/forgot_password_confirmed');
                $view->email = $user->email;
                $this->template->content = $view;
                return;
            }
            
        }
        
        $view = View::factory('admin/login/forgot_password');
        $this->template->content = $view;
    }
	
    public function action_new_password()
    {
        ini_set('max_execution_time', 1800);
        ini_set('memory_limit', '3G');
        $token = $this->params[0];
        
        // skip this if we don't have a token
        if( ! $token) $this->request->redirect ('/');
        
        $token = ORM::factory("AuthToken")->
                where('token', '=', $token)->
                find();
        
        $invalid_token = false;
        
        if( ! $token->loaded())
        {
            FlashMessenger::factory()->
                        set_message('error', 'Lo sentimos, el enlace que utiliz&oacute; para restaurar su contrase&ntilde;a no es v&aacute;lido.');
            $this->request->redirect('/');
        }
        else if($token->loaded() && ($token->type != 'reset_password' || $token->expiration_date < gmdate('Y-m-d H:i:s')))
        {
            $token->delete();
            FlashMessenger::factory()->
                        set_message('error', 'Lo sentimos, el enlace que utiliz&oacute; para restaurar su contrase&ntilde;a no es v&aacute;lido.');
            $this->request->redirect('/');
        }
        
        if(count($_POST))
        {
            $user = Model::factory("User")->where('id', '=', $token->user_id)->find();
            $user->password = $_POST['password'];
            $user->save();

            $this->session->set('user_id', $user->id);

            FlashMessenger::factory()->
            set_message('success', 'Tu contrase&ntilde;a se restableci&oacute; exitosamente.');

            $this->request->redirect('/admin/');
        }
        
        $view = View::factory('admin/login/new_password');
        $this->template->content = $view;
    }
    
}