<?php defined('SYSPATH') or die('No direct script access.');



class Controller_Admin_Order extends Controller_Containers_Admin {
    
    
    public function action_index() 
    {
        $orders = ORM::factory('Order')->find_all();
        
        $action_invoice = ORM::factory('Action')->where('link', '=', 'admin/order/invoice')->find();
        $view = View::factory( 'admin/order/index' );
        $status_values= Model_Order::$status_values;
        $view->set("orders", $orders);
        $view->set("current_user", $this->current_user);
        
        $view->set("action_invoice", $action_invoice);
        $view->set("status_values", $status_values);
        $this->template->content = $view;
        
    }

    public function action_cancel() 
    {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $order = ORM::factory('Order', $id);

            if ($order->loaded()) 
            {
                
                    $order->status = 'CANCELED';
                    
                    $message = Kohana::message('admin', 'order:cancel:success');
               
                if ($order->save()) 
                {
                    FlashMessenger::factory()->set_message('success', $message);
                } else 
                {
                    FlashMessenger::factory()->set_message('error', Kohana::message('admin', 'order:cancel:error'));
                }
            }

            $array = array('cancel' => (int) $order->id);
            echo json_encode($array);
        }
    }
   
    public function action_detail()
    {
        
        $view=View::factory('admin/order/detail');
        $order=  ORM::factory('Order',$this->params[0]);
        $orderproducts=  ORM::factory('OrderProduct')->where('order_id', '=', $order->id)->find_all();
        $items=count($orderproducts);
        $view->set("orderproducts", $orderproducts);
        $view->set("items", $items);
        $view->set("order", $order);
        $this->template->content = $view;
        
    }
    
    public function action_invoice()
    {
        
        $view=View::factory('admin/order/invoice');
        $order=  ORM::factory('Order',$this->params[0]);
        $orderproducts=  ORM::factory('OrderProduct')->where('order_id', '=', $order->id)->find_all();
        $invoice= ORM::factory('Invoice')->where('order_id', '=', $order->id)->find();
        if(!$invoice->loaded())
        {
            $invoice->order_id=$order->id;
            $invoice->address=$order->customer->address;
            $invoice->subtotal=$order->subtotal;
            $invoice->iva=$order->iva;
            $invoice->total=$order->total;
            if($invoice->save())
            {
                $namecustomer=$order->customer->name.' '.$order->customer->last_name;
                Model_Globalfunctions::send_invoice_mail($namecustomer,$order->customer->email,$order->id);
            }
            $order->status='SHIPPED';
            $order->save();
            
        }
        
        $view->set("orderproducts", $orderproducts);
        $view->set("order", $order);
        $view->set("invoice", $invoice);
        $this->template->content = $view;
        
    }
    
    public function action_pdf()
	{
                
		$this->auto_render = FALSE;
		$id = $this->params[0];
		require_once('modules/tcpdf/config/lang/spa.php');
		require_once('modules/tcpdf/tcpdf.php');

		// create new PDF document
		$pdf = new TCPDF(PDF_PAGE_ORIENTATION, PDF_UNIT, PDF_PAGE_FORMAT, true, 'UTF-8', false);

		// set document information
		$pdf->SetCreator(PDF_CREATOR);
		$pdf->SetAuthor('Importadora Dávila');
		$pdf->SetTitle('Importadora Dávila');
		$pdf->SetSubject('PDF FACTURA');
		$pdf->SetKeywords('TCPDF, PDF, formulario, test, guide');

		// set default header data
//		$pdf->SetHeaderData(PDF_HEADER_LOGO, PDF_HEADER_LOGO_WIDTH, PDF_HEADER_TITLE, PDF_HEADER_STRING);
                // remove default header/footer
                $pdf->setPrintHeader(false);
                $pdf->setPrintFooter(false);
		// set header and footer fonts
		$pdf->setHeaderFont(Array(PDF_FONT_NAME_MAIN, '', PDF_FONT_SIZE_MAIN));
		$pdf->setFooterFont(Array(PDF_FONT_NAME_DATA, '', PDF_FONT_SIZE_DATA));

		// set default monospaced font
		$pdf->SetDefaultMonospacedFont(PDF_FONT_MONOSPACED);

		//set margins
		$pdf->SetMargins(PDF_MARGIN_LEFT, PDF_MARGIN_TOP, PDF_MARGIN_RIGHT);
		$pdf->SetHeaderMargin(PDF_MARGIN_HEADER);
		$pdf->SetFooterMargin(PDF_MARGIN_FOOTER);

		//set auto page breaks
		$pdf->SetAutoPageBreak(TRUE, PDF_MARGIN_BOTTOM);

		//set image scale factor
		$pdf->setImageScale(PDF_IMAGE_SCALE_RATIO);

		//set some language-dependent strings
		//$pdf->setLanguageArray($l);
                $pdf->setCellHeightRatio(2);
		// add a page
		$pdf->AddPage();
		// get  file content
		
		$order=  ORM::factory('Order',$this->params[0]);
                $invoice= ORM::factory('Invoice')->where('order_id', '=', $order->id)->find();

                if( $invoice->loaded())
                {
                    $orderproducts=  ORM::factory('OrderProduct')->where('order_id', '=', $order->id)->find_all();
                    $num=count($orderproducts);
                    if(count($orderproducts)>0)
                {
                    $table_products='<table><thead><tr>
                <th style="font-size:30px;width:80px;"></th>
                <th style="font-size:30px;width:80px;"></th>
                <th style="font-size:30px;width:80px;"></th>
                <th style="font-size:30px;width:80px;"></th>
                <th style="font-size:30px;width:80px;"></th>
                
                    </tr> </thead><tbody>';
                    $height=578;
                    $cont=1;
                    foreach ($orderproducts as $orderproduct){
                        if($cont<$num)
                        {
                            $table_products.='<tr>
                                        <td style="font-size:30px;width:80px;">'.$orderproduct->product->code.'</td>
                                        <td style="font-size:30px;width:430px;">'.$orderproduct->product->description.'</td>
                                        <td style="font-size:30px; width:40px;">'.$orderproduct->stock.'</td>
                                        <td style="font-size:30px;width:60px;">'.$orderproduct->price.'</td>
                                        <td style="font-size:30px;width:60px;">'.$orderproduct->stock*$orderproduct->price.'</td>
                                       
                                    </tr> '; 
                                            $height-=22;
                                            $cont++;
                        }
                        else   
                        {
                            $table_products.='<tr>
                                        <td style="font-size:30px;width:80px;height:'.$height.'">'.$orderproduct->product->code.'</td>
                                        <td style="font-size:30px;width:430px;height:'.$height.'">'.$orderproduct->product->description.'</td>
                                        <td style="font-size:30px; width:40px;height:'.$height.'">'.$orderproduct->stock.'</td>
                                        <td style="font-size:30px;width:60px;height:'.$height.'">'.$orderproduct->price.'</td>
                                        <td style="font-size:30px;width:60px;height:'.$height.'">'.$orderproduct->stock*$orderproduct->price.'</td>
                                       
                                    </tr> '; 
                        }
                    
                    }                       
                    $table_products.='</tbody> </table>';
                }
                
                
		
                $table_data="";
                
                    $table_data='<table><thead><tr>
                <th style="font-size:30px;width:40px;height:17px;"></th>
                <th style="font-size:30px;width:335px;height:17px;"></th>
                <th style="font-size:30px;width:185px;height:17px;"></th>
                <th style="font-size:30px;width:120px;height:17px;"></th>
                
                    </tr> </thead>
        <tbody>';
                    
                    $table_data.='<tr>
                                        <td style="font-size:30px;width:40px;"></td>
                                        <td style="font-size:30px;width:335px;">'.$order->customer->name." ".$order->customer->last_name.'</td>
                                        <td style="font-size:30px; width:185px;">'.$order->customer->ruc.'</td>
                                        <td style="font-size:30px;width:120px;"></td>
                                    </tr>
                                    <tr>
                                        <td style="font-size:30px;width:40px;"></td>
                                        <td style="font-size:30px;width:335px;">'.$invoice->address.'</td>
                                        <td style="font-size:30px; width:185px;">'.$order->customer->phone.'</td>
                                        <td style="font-size:30px;width:120px;">'.$order->date.'</td>
                                    </tr>
                                    <tr>
                                        <td style="font-size:30px;width:40px;"></td>
                                        <td style="font-size:30px;width:335px;">'.$order->customer->city->name.'</td>
                                        <td style="font-size:30px; width:185px;"></td>
                                        <td style="font-size:30px;width:120px;"></td>
                                    </tr>
                                    ';    
                    
                    $table_data.='</tbody>    
    </table>';
                    
                    
                    $table_ammount="";
                
                    $table_ammount='<table>
        <tbody>';
                    
                    $table_ammount.='<tr>
                                        <td style="font-size:30px;width:510px;"></td>
                                        <td style="font-size:30px;width:90px;">SUBTOTAL</td>
                                        <td style="font-size:30px;width:70px;">'.$invoice->subtotal.'</td>
                                    </tr>
                                    <tr>
                                        <td style="font-size:30px;width:510px;"></td>
                                        <td style="font-size:30px;width:90px;">12% IVA</td> 
                                        <td style="font-size:30px;width:70px;">'.$invoice->iva.'</td> 
                                    </tr>
                                    <tr>
                                        <td style="font-size:30px;width:510px;"></td>
                                        <td style="font-size:30px;width:90px;">TOTAL</td>
                                        <td style="font-size:30px;width:70px;">'.$invoice->total.'</td>
                                    </tr>
                                   
                                    ';    
                    
                    $table_ammount.='</tbody>    
    </table>';
                  
                $utf8text ='<br><br><br>'.$table_data.'<br>'.$table_products.$table_ammount;
                        
                
		$pdf->writeHTML($utf8text, true, false, true, false, '');
		// ---------------------------------------------------------
		//Save to disk PDF document
		ob_start();
		$pdf->Output('factura_importadora_davila'.$id.'.pdf', 'I');
		exit();
                }
                else {
                    throw new Exception_ContentNotFound;
                }
	}
    
    
}

?>
