<?php defined('SYSPATH') or die('No direct script access.');



class Controller_Admin_Product extends Controller_Containers_Admin {
    
    
    public function action_index() 
    {
        $products = ORM::factory('Product')->find_all();
        
        $action_update = ORM::factory('Action')->where('link', '=', 'admin/product/update')->find();
        $action_create = ORM::factory('Action')->where('link', '=', 'admin/product/create')->find();
        $view = View::factory( 'admin/product/index' );
        $view->set("type_values", Model_Product::$type_values);
        $view->set("action_update",$action_update);
        $view->set("action_create",$action_create);
        $view->set("current_user", $this->current_user);
        $view->set("products", $products);
        
        $this->template->content = $view;
    }

    public function action_create() 
    {
        $view = View::factory( 'admin/product/create' );

        $product = ORM::factory('Product', $this->params[0]);
        $current_picture="";
        
        
        if (!empty($_POST)) 
        {
            try 
            {
                //**************** MESSAGE DISCRIMINATION SECTION
                if ($product->id) 
                {
                    $success_message = Kohana::message('admin', 'product:update:success');
                    $current_picture=$product->image;
                } else 
                {
                    $success_message = Kohana::message('admin', 'product:create:success');
                }
		
                $product->values($_POST);
                
               
                $product->save();
                if($product->image != $current_picture)
                {
                    if(file_exists(DOCROOT . 'media/productsimages/' . $product->id.'/'.$current_picture))
                        unlink(DOCROOT . 'media/productsimages/' . $product->id.'/'.$current_picture);
                    $product->image = self::move_file($product->id, $_POST['image']);
                }
                    
                
                $product->save();
                
                
                FlashMessenger::factory()->set_message('success', $success_message);
                $this->request->redirect('admin/product/index');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }

        $view->set("current_user", $this->current_user);
    
        $view->set("product", $product);

        $view->set("type_values", Model_Product::$type_values);

        $this->template->content = $view;
    }

    public function action_update() 
    {
        $product = ORM::factory('Product', $this->params[0]);

        if ($product->loaded()) 
        {
            $this->request->redirect('admin/product/create/' . $product->id);
        }

        throw new Exception_ContentNotFound;
    }

    public function action_delete() 
    {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $product = ORM::factory('Product', $id);

            if ($product->loaded()) 
            {
                              
            if ($product->delete()) 
                {
      
                $message = Kohana::message('admin', 'product:delete:success');
            }
            else{
                
                 $message = Kohana::message('admin', 'product:delete:error');
            }
  
            }

            $array = array('delete' => 1);
            echo json_encode($array);
        }
    }
    
    public function action_upload_file()
    {
        $this->auto_render = false;
        $allowedExtensions = array("jpeg","jpg", "bmp","png");
        // max file size in bytes
        $sizeLimit = 2 * 1024 * 1024;
        $uploader = new FileUploader($allowedExtensions, $sizeLimit);
        // Call handleUpload() with the name of the folder
        $result = $uploader->handleUpload(DOCROOT.'media/temp/');
                if( array_key_exists('success', $result) )
                {
                        $idir = "../media/temp/";
                        $file_ext = strrchr($result['filename'], '.'); 
                        $destination='image_'.time().$file_ext; 
                        foreach ($allowedExtensions as $extension) {
                            if (strcmp($file_ext,$extension)) { 
                            move_uploaded_file($result['filename'], "$idir" . $destination);        
                        }
                        } 
                } 
        // pass data through iframe
        echo htmlspecialchars(json_encode($result), ENT_NOQUOTES);
    }
    
    public static function move_file($folder, $file)
    {   
        if ($file && file_exists(DOCROOT .'media/temp/'. $file)) 
        {
            //path to upload image
            
            if(!is_dir(DOCROOT. 'media/productsimages/'.$folder))
            {
                $path = DOCROOT. 'media/productsimages/'.$folder;
                mkdir($path);
                chmod($path, 0777);
            }           
            //MOVING FILE FROM TEMP FOLDER
            $directory = 'media/productsimages/'.$folder.'/';           
            //copy(DOCROOT . 'media/temp/' . $file, DOCROOT . $directory . $file)
            if(copy(DOCROOT . 'media/temp/' . $file, DOCROOT . $directory . $file)) 
            {
                unlink(DOCROOT . 'media/temp/' . $file);                                
                return $file;
            }
            return NULL;
        }       
        return NULL;
    }
    
    
    
}

?>
