<?php

defined('SYSPATH') or die('No direct script access.');


class Controller_Admin_Profile extends Controller_Containers_Admin {

    public function action_index() 
    {
        $profiles=ORM::factory('Profile')->find_all();
        $action_update = ORM::factory('Action')->where('link', '=', 'admin/profile/update')->find();
        $action_create = ORM::factory('Action')->where('link', '=', 'admin/profile/create')->find();	
        $view = View::factory( 'admin/profile/index' );
        $view->set("action_update",$action_update);
        $view->set("action_create",$action_create);
        $view->set("current_user",$this->current_user);
        $view->set('status_values', ORM::factory('Profile')->status_values);
        $view->set("profiles",$profiles);
        $this->template->set('content',$view);
    }

    public function action_create() 
    {
        $view = View::factory( 'admin/profile/create' );

        $profile = ORM::factory('Profile', $this->params[0]);       
        $b=0;
        if (!empty($_POST)) 
        {

            try 
            {

                //**************** MESSAGE DISCRIMINATION SECTION
                if ($profile->id) 
                {
                    
                    $success_message = Kohana::message('admin', 'profile:update:success');
                    
                    $b=1;
                    
                } else 
                {
                    $success_message = Kohana::message('admin', 'profile:create:success');
                    $b=0;
                }

//
                if (!array_key_exists('status',$_POST))
                    $_POST['status'] = 'ACTIVE';

                if($_POST['id'])$profile->id = $_POST['id'];
                $profile->name=$_POST['name'];
                $profile->status=$_POST['status'];
                $profile->save();
                
                $select = DB::select()->from('profile_actions')->where('profile_id', '=', $profile->id)->as_object()->execute();
               // $select->execute();
                $from="";
                foreach ($select as $sl) {
                    $from.=$sl->action_id.", ";
                }
                 // Delete all assigned actions for that profile
                $query = DB::delete('profile_actions')->where('profile_id', '=', $profile->id);
                $query->execute();
				
				// Save new actions
                $to="";
                if(isset($_POST['actions']))
				{
                    foreach ($_POST['actions'] as $action_id)
					{
                        $new_profile_action = ORM::factory('ProfileAction');
                        $new_profile_action->profile_id = $profile->id;
                        $new_profile_action->action_id = $action_id;
                        $new_profile_action->save();
                        $to.=$action_id.", ";
                    }
                }
                
                
                FlashMessenger::factory()->set_message('success', $success_message);
                $this->request->redirect('admin/profile');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }
        $view->set("profile", $profile);
//        $view->set("profile_action", $profile_action);
        $view->set('status_values', Model_Globalfunctions::unshift_select_item(ORM::factory('Profile')->status_values));
        $view->actions = ORM::factory("Action")->where('parent_id','=', null)->find_all();
        if($profile->id)
        {
            $profile_actions_object = ORM::factory('ProfileAction')->where('profile_id', '=', $profile->id)->find_all();
            $profile_actions = array();
            foreach ($profile_actions_object as $p_action)
            {
                $profile_actions[] = $p_action->action_id;
            }           
        }
        else
            $profile_actions = array('');
        $view->profile_actions = $profile_actions;
        $this->template->set('content',$view);
    }
    public static function sweep_actions($actions, $level = -1)
	{
        $actionObjects = array();
        $level++;
        foreach ($actions as $action)
		{
            $aux = array();
            $aux['object']= $action;
            $aux['level']= $level;
            
            array_push($actionObjects, $aux);

            $children = $action->children->find_all();
            if(count($children))
			{
                foreach(self::sweep_actions($children, $level) as $c)
				{
                    array_push($actionObjects, $c);
                }
            }
        }
         return $actionObjects;
    } 
    public function action_update() 
    {
        $profile = ORM::factory('Profile', $this->params[0]);

        if ($profile->loaded()) 
        {
            $this->request->redirect('admin/profile/create/' . $profile->id);
        }

        throw new Exception_ContentNotFound;
    }
    
    public function action_deactivate() 
    {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $profile = ORM::factory('Profile', $id);

            if ($profile->loaded()) 
            {
                if ($profile->status == 'ACTIVE') 
                {
                    $profile->status = 'INACTIVE';
                    
                    $message = Kohana::message('admin', 'profile:inactive:success');
                } else 
                {
                    $profile->status = 'ACTIVE';
                    
                    $message = Kohana::message('admin', 'profile:active:success');
                }

                if ($profile->save()) 
                {
                   
					$users = ORM::factory('User')->where('profile_id', '=', $profile->id)->find_all()->as_array('id','id');
					
					if(count($users)>0){
						if($profile->status == 'INACTIVE'){
							foreach($users as $key => $value){
								$user=  ORM::factory('User', $value);
								$user->status = 'INACTIVE';
								$user->save();
							}
						}
						else if($profile->status == 'ACTIVE')
						{

							foreach($users as $key => $value){
								$user=  ORM::factory('User', $value);
								$user->status = 'ACTIVE';
								$user->save();
							}
						}
					}
					
                    FlashMessenger::factory()->set_message('success', $message);
                } else 
                {
                    FlashMessenger::factory()->set_message('error', Kohana::message('admin', 'profile:deactive:error'));
                }
            }

            $array = array('saved' => (int) $profile->id);
            echo json_encode($array);
        }
    }
    
}
