<?php defined('SYSPATH') or die('No direct script access.');



class Controller_Admin_Provider extends Controller_Containers_Admin {
    
    
    public function action_index() 
    {
        $providers = ORM::factory('Provider')->find_all();
        $action_update = ORM::factory('Action')->where('link', '=', 'admin/provider/update')->find();
        $action_create = ORM::factory('Action')->where('link', '=', 'admin/provider/create')->find();
        $view = View::factory( 'admin/provider/index' );
        $view->set("action_update",$action_update);
        $view->set("action_create",$action_create);
        $view->set("current_user", $this->current_user);
        $view->set("providers", $providers);
        $view->set('status_values', ORM::factory('Provider')->status_values);
        $this->template->content = $view;
    }

    public function action_create() 
    {
        $view = View::factory( 'admin/provider/create' );
        $provider = ORM::factory('Provider', $this->params[0]);
        $provinces = ORM::factory('Province')->order_by("name")->find_all()->as_array("id", "name");
        $province_id=0;
        $cities=array();
        if ($provider->id)
        {
         $city= ORM::factory('City',$provider->city_id);
         $province_id=$city->province_id;   
         $cities=ORM::factory('City')->where("province_id", "=", $province_id)->find_all()->as_array("id", "name");
         
        } 
        
        
        if (!empty($_POST)) 
        {
            try 
            {
                //**************** MESSAGE DISCRIMINATION SECTION
                if ($provider->id) 
                {
                    $success_message = Kohana::message('admin', 'provider:update:success');
                } else 
                {
                    $success_message = Kohana::message('admin', 'provider:create:success');
                }
				
				
                

                $provider->values($_POST);
                
                
                $provider->save();
                
                
                FlashMessenger::factory()->set_message('success', $success_message);
                $this->request->redirect('admin/provider/index');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }

        $view->set("current_user", $this->current_user);
        $view->set("status_values", Model_Globalfunctions::unshift_select_item(ORM::factory('Provider')->status_values));
        $view->set("provider", $provider);
        $view->set("provinces", $provinces);
        $view->set("province_id",$province_id);
        $view->set("cities",$cities);
        $this->template->content = $view;
    }

    public function action_update() 
    {
        $provider = ORM::factory('Provider', $this->params[0]);

        if ($provider->loaded()) 
        {
            $this->request->redirect('admin/provider/create/' . $provider->id);
        }

        throw new Exception_ContentNotFound;
    }

    public function action_deactivate() 
    {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $provider = ORM::factory('Provider', $id);

            if ($provider->loaded()) 
            {
                if ($provider->status == 'ACTIVE') 
                {
                    $provider->status = 'INACTIVE';
                   
                    $message = Kohana::message('admin', 'provider:inactive:success');
                } else 
                {
                    $provider->status = 'ACTIVE';
                    
                    $message = Kohana::message('admin', 'provider:active:success');
                }
                
                
                if ($provider->save()) 
                {
                    FlashMessenger::factory()->set_message('success', $message);
                } else 
                {
                    FlashMessenger::factory()->set_message('error', Kohana::message('admin', 'provider:deactive:error'));
                }
            }

            $array = array('saved' => (int) $provider->id);
            echo json_encode($array);
        }
    }
    
    
    
}

?>
