<?php defined('SYSPATH') or die('No direct script access.');



class Controller_Admin_Purchase extends Controller_Containers_Admin {
    
    
    public function action_index() 
    {
        $purchases = ORM::factory('Purchase')->find_all();
        
        $action_delete = ORM::factory('Action')->where('link', '=', 'admin/purchase/delete')->find();
        $action_create = ORM::factory('Action')->where('link', '=', 'admin/purchase/create')->find();
  
        $view = View::factory( 'admin/purchase/index' );
     
        $view->set("action_create",$action_create);
        
        $view->set("current_user", $this->current_user);
        $view->set("purchases", $purchases);
        $view->set("action_delete",$action_delete);
       
        $this->template->content = $view;
    }

    public function action_create() 
    {
        $view = View::factory('admin/purchase/create' );
        $purchase = ORM::factory('Purchase', $this->params[0]);
        $providers = ORM::factory('Provider')->order_by("name")->find_all()->as_array("id", "name");
        $products = ORM::factory('Product')->order_by("code")->find_all()->as_array("id", "code");
        $parameter=ORM::factory('Parameter')->where("description",'=','Impuesto IVA')->find();
        $parameter2=ORM::factory('Parameter')->where("description",'=','Porcentaje ganancia')->find();
        $numitems=1;
        $update=0;
        $products2=ORM::factory('PurchaseProduct')->where("purchase_id",'=',$purchase->id)->find_all();
        if(count($products2)>0)
        {
            $numitems= count($products2);   
        }
        else
        {
            $numitems=1;
        }
        if($purchase->id)
        {
            $update=1;
        }
        else
            $update=0;
        $iva=$parameter->value;
        $gain=$parameter2->value;
        $gain+=1;
        
        if (!empty($_POST)) 
        {
            try 
            {
                //**************** MESSAGE DISCRIMINATION SECTION
                if ($purchase->id) 
                {
                    $success_message = Kohana::message('admin', 'purchase:update:success');
                } else 
                {
                    $success_message = Kohana::message('admin', 'purchase:create:success');
                }
                $purchase->values($_POST);
                $purchase->save();
                
                if($update==1)
                {
                    foreach ($products2 as $currentproduct)
                    {
                        if(!in_array($currentproduct->product_id,$_POST['id_product']))
                        {
                            $substract_product=  ORM::factory('Product',$currentproduct->product_id);
                            $substract_product->stock-= $currentproduct->stock;
                            $substract_product->save();
                            $delete_product_purchase = new Model_Product($substract_product->id);
                            $purchase->remove('products',$delete_product_purchase);
                            
                        }
                    }
                }
                
                    foreach ($_POST['products'] as $num=>$product) {
                            $difference_stock=0;
                            $current_stock=0;
                            $searched_product=ORM::factory('Product')->where("code",'=',$product)->find();
                            if($update==0)
                            {
                                $searched_product->stock+=$_POST['quantities'][$num];
                                $purchase_product=ORM::factory('PurchaseProduct');
                                $purchase_product->purchase_id=$purchase->id;
                                $purchase_product->product_id=$searched_product->id;
                                $purchase_product->buy_price=$_POST['ups'][$num];
                                $purchase_product->stock=$_POST['quantities'][$num];
                                $purchase_product->save();
                            }
                            else {
                                $aux_purchase_product=  ORM::factory('PurchaseProduct')->where('product_id', '=', $searched_product->id)->and_where('purchase_id', '=', $purchase->id)->find();
                                $current_stock=$aux_purchase_product->stock;
                                
                                $delete_product_purchase = new Model_Product($searched_product->id);
                                $purchase->remove('products',$delete_product_purchase);
                                
                                $purchase_product=ORM::factory('PurchaseProduct');
                                $purchase_product->purchase_id=$purchase->id;
                                $purchase_product->product_id=$searched_product->id;
                                
                                

                                if($_POST['quantities'][$num]!= $current_stock)
                                {
                                    $difference_stock=$_POST['quantities'][$num]-$current_stock;
                                    $searched_product->stock+=$difference_stock;
                                }
                                $purchase_product->buy_price=$_POST['ups'][$num];
                                $purchase_product->stock=$_POST['quantities'][$num];
                                $purchase_product->save();
                            }
                            $searched_product->buy_price=$_POST['ups'][$num];
                            $searched_product->sell_price=$searched_product->buy_price*$gain;
                            $searched_product->save();
                            
                            
                    }   

                FlashMessenger::factory()->set_message('success', $success_message);
                $this->request->redirect('admin/purchase/index');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }

        $view->set("current_user", $this->current_user);
        $view->set("purchase", $purchase);
        $view->set("providers",$providers);
        $view->set("products",$products);
        $view->set("iva",$iva);
        $view->set("numitems",$numitems);
  
        $view->set("type_values",  Model_Product::$type_values);
        
        $view->set("products2",$products2);
        $this->template->content = $view;
        
    }

    
    public function action_update() 
    {
        $purchase = ORM::factory('Purchase', $this->params[0]);

        if ($purchase->loaded()) 
        {
            $this->request->redirect('admin/purchase/create/' . $purchase->id);
        }

        throw new Exception_ContentNotFound;
    }
    

    public function action_delete() 
   {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $purchase = ORM::factory('Purchase', $id);
            
            if ($purchase->loaded()) 
            {
                $products_purchase= ORM::factory('PurchaseProduct')->where("purchase_id",'=',$purchase->id)->find_all();
                foreach ($products_purchase as $currentproduct) {
                    
                    $substract_product=  ORM::factory('Product',$currentproduct->product_id);
                    $substract_product->stock-= $currentproduct->stock;
                    $substract_product->save();
                    
                    $products_purchasedelete = new Model_Product($currentproduct->product_id);
                    $purchase->remove('products',$products_purchasedelete);
                }   
            if ($purchase->delete()) 
            {
      
                $message = Kohana::message('admin', 'purchase:delete:success');
            }
            else{
                
                 $message = Kohana::message('admin', 'purchase:delete:error');
            }
  
            }

            $array = array('delete' => 1);
            echo json_encode($array);
        }
    }
    
    
    
}

?>
