<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Admin_User extends Controller_Containers_Admin {

    public function action_index() 
    {
        $users = ORM::factory('User')->and_where('id', '!=', 1)->and_where('id', '!=', 2)->find_all();
        $profiles=ORM::factory('Profile')->where('id', '!=', 1)->find_all();
        $action_update = ORM::factory('Action')->where('link', '=', 'admin/user/update')->find();
        $action_create = ORM::factory('Action')->where('link', '=', 'admin/user/create')->find();

	          
        $profiles_array=array(); 
        if(count($profiles)>0){
            foreach ($profiles as $key => $value) {
                    $profiles_array[$value->id]=$value->name;
            }
        }        
        $view = View::factory( 'admin/user/index' );
        $view->set("action_update",$action_update);
        $view->set("action_create",$action_create);
        $view->set("current_user", $this->current_user);
        $view->set("users", $users);
        $view->set('status_values', ORM::factory('User')->status_values);
        $view->set("profiles_array",$profiles_array);
        $this->template->content = $view;
    }

    public function action_create() 
    {
        $view = View::factory( 'admin/user/create' );

        $user = ORM::factory('User', $this->params[0]);
        $profiles_array = ORM::factory('Profile')->where('id', '!=', 1)->find_all()->as_array('id','name');
	//remove provider's profile since a user can´t be a provider
//        unset($profiles_array[2]);
        $b=0;
	if (!empty($_POST)) 
        {
            try 
            {
                //**************** MESSAGE DISCRIMINATION SECTION
                if ($user->id) 
                {
                    $success_message = Kohana::message('admin', 'user:update:success');
                    $userbefore = ORM::factory('User', $this->params[0]);
                    $b=1;
                } else 
                {
                    $success_message = Kohana::message('admin', 'user:create:success');
                    $b=0;
                }
				
				
                //**************** CHANGE/CREATE PASSWORD SECTION
                if ($_POST['password'] == '_pass_flag_') 
                {
                    unset($_POST['password']);
                }

                $user->values($_POST);
                if(!$user->id)
                {
                    $user->username = Model_Globalfunctions::generate_user(array( 'firstname' => $user->name , 
                                     'lastname' => $user->last_name ,
                                     'fields'=> 'username',
                                     'class'=> 'users',
                                     'db'=>'db'));
                
                   

                }
                
                $user->save();
                
                
                FlashMessenger::factory()->set_message('success', $success_message);
                $this->request->redirect('admin/user/index');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }

        $view->set("current_user", $this->current_user);
        $view->set("status_values", Model_Globalfunctions::unshift_select_item(ORM::factory('User')->status_values));
        $view->set("user", $user);
        $view->set("profiles_array",Model_Globalfunctions::unshift_select_item($profiles_array));
        $this->template->content = $view;
    }

    public function action_update() 
    {
        $user = ORM::factory('User', $this->params[0]);

        if ($user->loaded()) 
        {
            $this->request->redirect('admin/user/create/' . $user->id);
        }

        throw new Exception_ContentNotFound;
    }

    public function action_deactivate() 
    {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $user = ORM::factory('User', $id);

            if ($user->loaded()) 
            {
                if ($user->status == 'ACTIVE') 
                {
                    $user->status = 'INACTIVE';
                   
                    $message = Kohana::message('admin', 'user:inactive:success');
                } else 
                {
                    $user->status = 'ACTIVE';
                    
                    $message = Kohana::message('admin', 'user:active:success');
                }
                
                
                if ($user->save()) 
                {
                    FlashMessenger::factory()->set_message('success', $message);
                } else 
                {
                    FlashMessenger::factory()->set_message('error', Kohana::message('admin', 'user:deactive:error'));
                }
            }

            $array = array('saved' => (int) $user->id);
            echo json_encode($array);
        }
    }
    
    public function action_acount() 
    {
        $view = View::factory( 'admin/user/acount' );

        $user = ORM::factory('User', $this->current_user->id);

        if (!empty($_POST)) 
        {
            try 
            {
                //**************** MESSAGE DISCRIMINATION SECTION
                if ($user->id) 
                {
                    $success_message = Kohana::message('admin', 'user:acount:success');
                } else 
                {
                    $success_message = Kohana::message('admin', 'user:acount:success');
                }
				
				
                //**************** CHANGE/CREATE PASSWORD SECTION
                if ($_POST['password'] == '_pass_flag_') 
                {
                    unset($_POST['password']);
                }

                $user->values($_POST);
                $user->save();

                FlashMessenger::factory()->set_message('success', $success_message);
                $this->request->redirect('/admin');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }

        $view->set("current_user", $this->current_user);
        $view->set('status_values', Model_Globalfunctions::unshift_select_item(ORM::factory('User')->status_values));
        $view->set("user", $user);
        $this->template->content = $view;
    }
	
	
}
