<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Client_Cart extends Controller_Containers_Client {

    public function action_index()
    {
        
        $view=View::factory('client/cart/index');
        $cartproducts=  ORM::factory('Cart')->where('customer_id', '=', $this->current_client)->find_all();
        $subtotal=0;
        $items=0;
        foreach ($cartproducts as $cartproduct) {
            $product=  ORM::factory('Product',$cartproduct->product_id);
            if($product->stock>=$cartproduct->quantity)
            {
                $subtotal+=$cartproduct->product->sell_price*$cartproduct->quantity;
                $items+=$cartproduct->quantity;
            }
        }
        
        $view->set("cartproducts", $cartproducts);
        $view->set("subtotal", $subtotal);
        $view->set("items", $items);
        $view->set('current_client', $this->current_client);
        $this->template->content = $view;
        
        
        if (!empty($_POST)) 
        {
                try 
                {
                    
                    if(count($cartproducts)>0 && $items>0)
                    {
                        $success_message = Kohana::message('client', 'order:create:success');
                        $parameter=  ORM::factory('Parameter',1);
                        $iva=$parameter->value;
                        $order=  ORM::factory('Order');
                        $order->customer_id=$this->current_client;
                        $order->status='ORDERED';
                        $order->date=  date('Y-m-d');
                        $order->subtotal=$subtotal;
                        $order->iva=$subtotal*$iva;
                        $order->total=$subtotal+$order->iva;
                        $order->save();
                     
                        Model_Globalfunctions::confirmation_purchase_mail($this->current_client->email, 'http://importadoradavila.com/client/payment/index/'.$order->id.'');
              
                        foreach ($cartproducts as $cartproduct) {
                            $productupdate=  ORM::factory('Product',$cartproduct->product_id);
                            if($productupdate->stock>=$cartproduct->quantity)
                            {
                                $orderproduct=  ORM::factory('OrderProduct');
                                $orderproduct->order_id=$order->id;
                                $orderproduct->product_id=$cartproduct->product_id;
                                $orderproduct->price=$cartproduct->product->sell_price;
                                $orderproduct->stock=$cartproduct->quantity;
                                $orderproduct->save();
                                $productupdate->stock-=$cartproduct->quantity;
                                $productupdate->save();
                                $cartdelete=  ORM::factory('Cart',$cartproduct->id);
                                $cartdelete->delete();
                            }
                            unset($orderproduct);
                        }

                        FlashMessenger::factory()->set_message('success', $success_message);
                        $this->request->redirect('client/payment/index/'.$order->id);
                    
                    }
                    else
                    {
                         FlashMessenger::factory()->set_message('error', 'Debes añadir al menos un producto con stock a tu lista para poder ordenar tus productos');
                        $this->request->redirect('client/welcome/index');
                    }
                    
                } 
                catch (ORM_Validation_Exception $ex) 
                {
                    foreach ($ex->errors('validation') as $error) 
                    {
                        FlashMessenger::factory()->set_message('error', $error);
                    }
                }
            
        }
    }
    
}
