<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Client_Order extends Controller_Containers_Client {

    public function action_index()
    {
        
        $view=View::factory('client/order/index');
        $orders = ORM::factory('Order')->where('customer_id', '=', $this->current_client)->find_all();
        $status_values= Model_Order::$status_values;
        $view->set("current_client", $this->current_client);
        $view->set("orders", $orders);
        $view->set("status_values", $status_values);
        
        $this->template->content = $view;
    }
    
    public function action_cancel() 
    {
        if ($this->request->is_ajax()) 
        {
            $this->auto_render = FALSE;
            $id = arr::get($this->request->post(), 'id');
            $order = ORM::factory('Order', $id);

            if ($order->loaded()) 
            {
                
                    $order->status = 'CANCELED';
                    
                    $message = Kohana::message('client', 'order:cancel:success');
               
                if ($order->save()) 
                {
                    FlashMessenger::factory()->set_message('success', $message);
                } else 
                {
                    FlashMessenger::factory()->set_message('error', Kohana::message('client', 'order:cancel:error'));
                }
            }

            $array = array('cancel' => (int) $order->id);
            echo json_encode($array);
        }
    }
    
    public function action_detail()
    {
        
        $view=View::factory('client/order/detail');
        $order=  ORM::factory('Order',$this->params[0]);
        $orderproducts=  ORM::factory('OrderProduct')->where('order_id', '=', $order->id)->find_all();
        $items=count($orderproducts);
        $customer=  ORM::factory('Customer',$this->current_client);
        $view->set("orderproducts", $orderproducts);
        $view->set("items", $items);
        $view->set("customer", $customer);
        $view->set("order", $order);
        $view->set('current_client', $this->current_client);
        $this->template->content = $view;
        
    }
    
    public function action_invoice()
    {
        
        $view=View::factory('client/order/invoice');
        $order=  ORM::factory('Order',$this->params[0]);
        $invoice= ORM::factory('Invoice')->where('order_id', '=', $order->id)->find();

        if($order->customer_id==$this->current_client && $invoice->loaded())
        {
            $orderproducts=  ORM::factory('OrderProduct')->where('order_id', '=', $order->id)->find_all();
            
            $view->set("orderproducts", $orderproducts);
            $view->set("order", $order);
            $view->set("invoice", $invoice);
        }
        else
        {
            $this->request->redirect('client/order/index');
        }
        
        $this->template->content = $view;
        
    }
    
}
