<?php defined('SYSPATH') or die('No direct script access.');


class Controller_Client_Profile extends Controller_Containers_Client {

    public function action_index() 
    {
        $view = View::factory( 'client/profile/index' );
        $customer = ORM::factory('Customer',$this->current_client);
        $provinces = ORM::factory('Province')->order_by("name")->find_all()->as_array("id", "name");
        $city= ORM::factory('City',$customer->city_id);
        $cities=ORM::factory('City')->where('province_id', '=', $city->province_id)->find_all()->as_array("id", "name");
        if (!empty($_POST)) 
        {
            if(isset($_POST['info_update']) && !isset($_POST['password_change']))
            {
                try 
                {
                    $success_message = Kohana::message('client', 'profile:update:success');
                    $customer->values($_POST);
                    $customer->save();
                    
                    FlashMessenger::factory()->set_message('success', $success_message);
                    $this->request->redirect('client/profile/index');
                } 
                catch (ORM_Validation_Exception $ex) 
                {
                    foreach ($ex->errors('validation') as $error) 
                    {
                        FlashMessenger::factory()->set_message('error', $error);
                    }
                }
            }
            elseif(!isset($_POST['info_update']) && isset($_POST['password_change']))
            {
                try 
                {
                    $success_message = Kohana::message('client', 'client:password:update');

                    $customer->password= $_POST['password'];
                    $customer->save();
                    FlashMessenger::factory()->set_message('success', $success_message);
                    $this->request->redirect('client/profile/index');
                } 
                catch (ORM_Validation_Exception $ex) 
                {
                    foreach ($ex->errors('validation') as $error) 
                    {
                        FlashMessenger::factory()->set_message('error', $error);
                    }
                }
            }
            
        }
 
        $view->set("provinces", $provinces);
        $view->set("customer", $customer);
        $view->set("cities",$cities);
        $view->set("city",$city);
        $this->template->set('content', $view);             
        $this->template->content = $view;
    }
    
   
}


