<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Client_Welcome extends Controller_Containers_Client {

    public function action_index()
    {
        
        $view=View::factory('client/welcome/index');
        $cartproducts=  ORM::factory('Cart')->where('customer_id', '=', $this->current_client)->find_all();
        $subtotal=0;
        $items=0;
        foreach ($cartproducts as $cartproduct) {
            $product=  ORM::factory('Product',$cartproduct->product_id);
            if($product->stock>=$cartproduct->quantity)
            {
                $subtotal+=$cartproduct->product->sell_price*$cartproduct->quantity;
                $items+=$cartproduct->quantity;
            }
        }
        
        $products= ORM::factory('Product')->find_all();
        $number_products=  count($products);
        if (!empty($_POST)) 
        {
                try 
                {
                    if(isset($_POST['button_search']))
                    {
                        $search=$_POST['description'];
                        if($_POST['search_radio']=='All')
                        {
                            $products=  ORM::factory('Product')->where('name', 'LIKE', '%'.$search.'%')->or_where('description', 'LIKE', '%'.$search.'%')->or_where('code', 'LIKE', '%'.$search.'%')->find_all();
                            $number_products=  count($products);
                        }
                        elseif($_POST['search_radio']=='Band')
                        {
                            $products=  ORM::factory('Product')->or_where_open()->where('name', 'LIKE', '%'.$search.'%')->or_where('description', 'LIKE', '%'.$search.'%')->or_where('code', 'LIKE', '%'.$search.'%')->or_where_close()->and_where('type', '=', 'BAND')->find_all();
                            $number_products=  count($products);
                        }
                        elseif($_POST['search_radio']=='Brakepad')
                        {
                            $products=  ORM::factory('Product')->or_where_open()->where('name', 'LIKE', '%'.$search.'%')->or_where('description', 'LIKE', '%'.$search.'%')->or_where('code', 'LIKE', '%'.$search.'%')->or_where_close()->and_where('type', '=', 'BRAKEPAD')->find_all();
                            $number_products=  count($products);
                        }
                   }
                elseif (isset($_POST['message_send'])) {
                    Model_Globalfunctions::send_message_mail($_POST['email'],$_POST['text']);
                    $this->request->redirect('?contact=1');
                }
                    
                } 
                catch (ORM_Validation_Exception $ex) 
                {
                    foreach ($ex->errors('validation') as $error) 
                    {
                        FlashMessenger::factory()->set_message('error', $error);
                    }
                }
            
        }
        $view->set("number_products", $number_products);
        $view->set("products", $products);
        $view->set("subtotal", $subtotal);
        $view->set("items", $items);
        $view->set('current_client', $this->current_client);
        $this->template->content = $view;
    }
    public function action_construction()
    {
        $this->view=View::factory('client/welcome/construction');
    }
    
}