<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Containers_Admin extends Controller_Template {

    public $template = 'containers/admin';
    public $params = array();
    public $current_user;
    protected $session;
    
    public function before()
    {
        parent::before();	
        $this->initializeSession();

        // Check if a user is logged in
        if( !$this->current_user
            && $this->request->controller() != 'login'
            && $this->request->action() != 'login')
        {
            Request::current()->redirect('admin/login/login/');
        }
        $this->params = explode('/',$this->request->param('params'));
         if( $this->current_user )
            //Verify if the user has access permission to the requested url
            if($this->request->controller() != "welcome" && $this->request->controller() != "index" && $this->request->controller() != "rpc" &&
            ! $this->current_user->has_access_permission('admin',$this->request->controller(), $this->request->action(),Model_User::$admin_allowed_actions, $this->params))
                    throw new Exception_Unauthorized;
        
        $this->template->styles = array();
        $this->template->scripts = array();
        $this->template->title = 'Importadora Dávila';
    }
	
    public function after()
    {		
        if ( $this->auto_render )
        {
            $action = $this->request->action();
            $controller =  $this->request->controller();

            //Build the styles array
            $css_file = 'media/css/controllers/admin/'.$controller.'/'.$action.'.css';
            $styles = array(
                    'media/css/blueprint/screen.css' => 'screen, projection',
                    'media/css/blueprint/print.css' => 'print',
                    'media/css/jquery-ui/smoothness/jquery-ui-1.8.16.custom.css' => 'all',
                    'media/css/dataTables/TableTools.css' => 'screen',
                    'media/css/dataTables/TableTools_JUI.css' => 'screen',
                    'media/css/jquery.dataTables.css' => 'screen',
                    'media/css/src/ie.css' => 'screen, projection',
                    'media/css/blueprint/ie.css' => 'print',
                    'media/css/styles.css' => 'screen',
                    'media/css/jquery.autocomplete.css' => 'screen',
                    'media/css/superfish.css' => 'screen',
                    'media/css/jquery-ui/jquery-ui.css' => 'screen',
                    'media/css/jquery.combobox.css' => 'screen',
                    'media/css/jquery.fancybox.css' => 'screen',
                    'media/css/fileuploader.css' => 'screen',

            );

            //VALIDATING FILE
            if(file_exists($css_file) )
            {
                    $styles = array_merge( $styles, array($css_file=>'screen') );
            }

            //Build the scripts array
            $js_file = 'media/js/controller/admin/'.$controller.'/'.$action.'.js';
            $scripts = array(
                    //'media/js/jqueryLibrary/jquery-1.6.2.min.js',
                    'media/js/jqueryLibrary/jquery-1.8.2.js',
                    'media/js/ajaxupload.js',
                    'media/js/fileuploader.js',
                    'media/js/jqueryLibrary/jquery-ui.js',
                    'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.js',
                    'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.min.js',
                    'media/js/jqueryLibrary/jquery.combobox.js',
                    'media/js/jqueryLibrary/jquery-validation.js',
                    'media/js/jqueryLibrary/jquery.autocomplete.js',
                    'media/js/dataTables/jquery.dataTables.js',
                    'media/js/dataTables/TableTools.js',
                    'media/js/dataTables/ZeroClipboard.js',
                    'media/js/globalfunctions.js',
                    'media/js/jquery.fancybox.js',
                    'media/js/menu/superfish.js' ,
                    'media/js/menu/hoverIntent.js',
                    'media/js/jquery.exptextarea.js',
                    'media/js/jquery.placeholder.js',
            );

            //VALIDATING FILE
            if(file_exists($js_file) )
            {
                    $scripts = array_merge( $scripts, array($js_file) );
            }


            $this->template->styles = array_merge( $styles, $this->template->styles );
            $this->template->scripts = array_merge( $scripts, $this->template->scripts );
            
            $user_id=Session::instance()->get('user_id');
            $current_user= ORM::factory('User',$user_id);
            
            if($current_user->loaded())
                $this->template->current_user = $current_user;
            
            //Get Menu		
            $menu= $this->_get_new_menu(NULL,$current_user->profile_id);

            if($menu){
                $this->template->menu = $menu;
            }else{
                $this->template->menu = false;
            }
            
        }		

        //Required because we are extending Controller_Template
        parent::after();		
    }
        
    private function _get_new_menu($option = NULL, $profile)
    {
        
        $this_level_items = ORM::factory('Profile')->get_profile_action($option , $profile);
        $cont=1;
          $result=''; 
        if ($this_level_items != FALSE)//if exist this level
        {
            foreach ($this_level_items as $current_item)
            {
                $actions = explode('/', $current_item['link']);
                if($actions[count($actions)-1] != 'update' && $actions[count($actions)-1] != 'delete' && $actions[count($actions)-1] != 'create' && $actions[count($actions)-1] != 'invoice')
                {
                    $style = (strlen(html_entity_decode($current_item['name'])) > 15 ) ? "style='padding-top:8px;'" : "";

                    $result .= "<li class=color_" . $cont . "   ><a href=\"";
                    if ($current_item['link'] != '#')
                        $result .= Url::site($current_item['link']);
                    else
                        $result .= '#';
                    $result .= "\"" . $style . ">" . $current_item['name'] . "</a>";
                    $next = self::_get_new_menu($current_item['id'],$profile);
                    if ($next != '')
                    {
                        $result .= "<ul style='margin-top:-4px'>" . $next . "</ul>";
                    }
                    $result .= "</li>";
                    $cont++;
                }
            }            
        }
        else
            return $result;
        return $result . "\n";
    }

    private function initializeSession()
    {
        $this->session = Session::instance();
        if( ! $this->session->get('user_id'))
        {
            if( ! isset($_COOKIE['login']))
            {
                $this->session->set('user_id', 0);
            }
//            else
//            {
////                $token = ORM::factory("AuthToken", $_COOKIE['login']);
//                if($token->loaded() && $token->expiration_dt < gmdate('Y-m-d H:i:s'))
//                {
//                    $token->delete();
//                    setcookie('login', '', time() - 60, '/');
//                }
//                else
//                {
//                    $this->session->set('user_id', $token->user_id);
//                }
//            }
        }
        
        if($this->session->get('user_id') > 0)
        {
            $this->current_user = new Model_User($this->session->get('user_id'));
            if( ! $this->current_user->loaded())
            {
                $this->current_user = null;
            }
        }
    }
    
    protected function logout()
    {
        // Invalidate "remember me" tokens
//        $token = ORM::factory('AuthToken')->
//                where('user_id', '=', Session::instance()->get('user_id'))->
//                where('type', '=', 'login')->
//                find();
//        
//        if($token->loaded())
//        {
//            $token->delete();
//        }
        
        $this->session->set('user_id', 0);
        $this->current_user = 0;
        
        return true;
    }
}
