<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Containers_Client extends Controller_Template {

    public $template = 'containers/client';
    public $params = array();
    public $current_client;
     
    protected $session;
    
    public function before()
    {
        parent::before();
        
       
        $this->initializeSession();
        
        // Check if a client is logged in
        if( !$this->current_client
            && $this->request->controller() != 'login'
            && $this->request->action() != 'login')
        {
            Request::current()->redirect('');
        }
        elseif ($this->current_client && $this->request->controller() != 'login' && $this->request->action() != 'changepassword')
        {
            $client_testing = ORM::factory('Customer', $this->current_client);
            
            if($client_testing->status == 'PENDING' && $this->request->controller() != 'welcome' && $this->request->action() != 'index')
            {
                Request::current()->redirect('client/welcome/index');
            }
            		
        }

        $this->params = explode('/',$this->request->param('params'));
        $this->template->styles = array();
        $this->template->scripts = array();
        $this->template->title = 'Importadora Dávila';
    }


    public function after()
    {     
        if ( $this->auto_render )
        {
            $action = $this->request->action();
            $controller =  $this->request->controller();

            $styles = array(
                    'media/css/blueprint/screen.css' => 'screen, projection',
                    'media/css/blueprint/print.css' => 'print',
                    'media/css/jquery-ui/smoothness/jquery-ui-1.8.16.custom.css' => 'all',
                    'media/css/dataTables/TableTools.css' => 'screen',
                    'media/css/dataTables/TableTools_JUI.css' => 'screen',
                    'media/css/jquery.dataTables.css' => 'screen',
                    'media/css/src/ie.css' => 'screen, projection',
                    'media/css/blueprint/ie.css' => 'print',
                    'media/css/styles.css' => 'screen',
                    'media/css/jquery.autocomplete.css' => 'screen',
                    'media/css/superfish.css' => 'screen',
                    'media/css/jquery-ui/jquery-ui.css' => 'screen',
                    'media/css/jquery.fancybox.css' => 'screen',
                    'media/css/client.css' => 'screen',
                    'media/css/jquery.combobox.css' => 'screen',
                    'media/css/simplePagination.css' => 'screen',
                    'media/css/fileuploader.css' => 'screen',
                    'media/css/jquery.bxslider.css'=> 'screen',
                    'media/css/jquery.thumbs.css'=> 'screen',
            );

            
            $scripts = array(
                    //'media/js/jqueryLibrary/jquery-1.6.2.min.js',
                    'media/js/jqueryLibrary/jquery-1.8.2.js',
                    'media/js/jqueryLibrary/jquery-ui.js',
                    'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.js',
                    'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.min.js',
                    'media/js/jqueryLibrary/jquery.combobox.js',
                    'media/js/jqueryLibrary/jquery-validation.js',
                    'media/js/jqueryLibrary/jquery.autocomplete.js',
                    'media/js/dataTables/jquery.dataTables.js',
                    'media/js/dataTables/TableTools.js',
                    'media/js/dataTables/ZeroClipboard.js',
                    'media/js/globalfunctions.js',
                    'media/js/menu/superfish.js' ,
                    'media/js/menu/hoverIntent.js',
                    'media/js/jquery.fancybox.js',
                    'media/js/responsiveslides.js',
                    'media/js/jquery.exptextarea.js',
                    'media/js/jquery.simplePagination.js',
                    'media/js/jquery.bxslider.js',
                    'media/js/jquery.easing.1.3.js',
                    'media/js/jquery.fitvids.js',
                    'media/js/jquery.placeholder.js',
                    'media/js/rslides1.js',
                    'media/js/jqIpLocation.js',
                    'media/js/jquery.thumbs.js',
                    'media/js/jquery.color.js'
            );

            

            $this->template->styles = array_merge( $styles, $this->template->styles );
            $this->template->scripts = array_merge( $scripts, $this->template->scripts );
            
            $client_id=Session::instance()->get('client_id');
            $current_client= ORM::factory('Customer',$client_id);
            if($current_client->loaded())
                $this->template->current_client = $current_client; 
            
        }		

        //Required because we are extending Controller_Template
        parent::after();		
    }
        
    private function initializeSession()
    {
        $this->session = Session::instance();
        if( ! $this->session->get('client_id'))
        {
            if( ! isset($_COOKIE['login']))
            {
                $this->session->set('client_id', 0);
            }
            else
            {
                $token = ORM::factory("AuthToken", $_COOKIE['login']);
                if($token->loaded() && $token->expiration_date < gmdate('Y-m-d H:i:s'))
                {
                    $token->delete();
                    setcookie('login', '', time() - 60, '/');
                }
                else
                {
                    $this->session->set('client_id', $token->client_id);
                }
            }
        }
        
        if($this->session->get('client_id') > 0)
        {
            $this->current_client = new Model_Customer($this->session->get('client_id'));
            if( ! $this->current_client->loaded())
            {
                $this->current_client = null;
            }
        }
    }
    
    protected function logout()
    {
        // Invalidate "remember me" tokens
        $token = ORM::factory('AuthToken')->
                where('customer_id', '=', Session::instance()->get('client_id'))->
                where('type', '=', 'login')->
                find();
        
        if($token->loaded())
        {
            $token->delete();
        }
        
        $this->session->set('client_id', 0);
        $this->current_client = 0;
        
        return true;
    }
}
