<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Containers_Default extends Controller_Template {

    public $template = 'containers/default';
    public $params = array();
    public $countries;
    public $cities;
    public $current_client;
    protected $session;
    
    public function before()
    {
        //Required because we are extending Controller_Template
        parent::before();	
        $this->initializeSession();

        $this->params = explode('/',$this->request->param('params'));
//         if( $this->current_client )
            //Verify if the user has access permission to the requested url
//            if($this->request->controller() != "default" && $this->request->controller() != "index" && $this->request->controller() != "rpc")
//                    throw new Exception_Unauthorized;
        
        $this->template->styles = array();
        $this->template->scripts = array();
        $this->template->title = 'Importadora Dávila';

    }
    
    public function after()
    {		
        if ( $this->auto_render )
        {
                $action = $this->request->action();
                $controller =  $this->request->controller();

                //Build the styles array
                $css_file = 'media/css/controllers/admin/'.$controller.'/'.$action.'.css';
                $styles = array(
                        'media/css/blueprint/screen.css' => 'screen, projection',
                        'media/css/blueprint/print.css' => 'print',
                        'media/css/jquery-ui/smoothness/jquery-ui-1.8.16.custom.css' => 'all',
                        'media/css/dataTables/TableTools.css' => 'screen',
                        'media/css/dataTables/TableTools_JUI.css' => 'screen',
                        'media/css/jquery.dataTables.css' => 'screen',
                        'media/css/src/ie.css' => 'screen, projection',
                        'media/css/blueprint/ie.css' => 'print',
                        'media/css/styles.css' => 'screen',
                        'media/css/jquery.autocomplete.css' => 'screen',
                        'media/css/superfish.css' => 'screen',
                        'media/css/jquery.fancybox.css' => 'screen',
                        'media/css/simplePagination.css' => 'screen',
                        'media/css/jquery-ui/jquery-ui.css' => 'screen',
                        'media/css/jquery.combobox.css' => 'screen',
                        'media/css/sweetPages.css' => 'screen', 
                        'https://vjs.zencdn.net/c/video-js.css' => 'screen',
                );

                //VALIDATING FILE
                if(file_exists($css_file) )
                {
                        $styles = array_merge( $styles, array($css_file=>'screen') );
                }

                //Build the scripts array
                $js_file = 'media/js/controller/admin/'.$controller.'/'.$action.'.js';
                $scripts = array(
                        //'media/js/jqueryLibrary/jquery-1.6.2.min.js',
                        'media/js/jqueryLibrary/jquery-1.8.2.js',
                        'media/js/jqueryLibrary/jquery-ui.js',
                        'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.js',
                        'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.min.js',
                        'media/js/jqueryLibrary/jquery.combobox.js',
                        'media/js/jqueryLibrary/jquery-validation.js',
                        'media/js/jqueryLibrary/jquery.autocomplete.js',
                        'media/js/dataTables/jquery.dataTables.js',
                        'media/js/dataTables/TableTools.js',
                        'media/js/dataTables/ZeroClipboard.js',
                        'media/js/globalfunctions.js',
                        'media/js/menu/superfish.js' ,
                        'media/js/menu/hoverIntent.js',
                        'media/js/jquery.fancybox.js',
                        'media/js/jquery.simplePagination.js',
                        'media/js/jquery.exptextarea.js',
                        'media/js/sweetPages.js',
                        'media/js/jquery.placeholder.js',
                        'https://vjs.zencdn.net/c/video.js',
                        'media/js/jqIpLocation.js',
                );

                //VALIDATING FILE
                if(file_exists($js_file) )
                {
                    $scripts = array_merge( $scripts, array($js_file) );
                }


                //Set styles and scripts on the template (container). This can also be
                //done from any action method
                $this->template->styles = array_merge( $styles, $this->template->styles );
                $this->template->scripts = array_merge( $scripts, $this->template->scripts );

        }		

        //Required because we are extending Controller_Template
        parent::after();		
    }
    
    private function initializeSession()
    {
        $this->session = Session::instance();
        if( ! $this->session->get('client_id'))
        {
            if( ! isset($_COOKIE['login']))
            {
                $this->session->set('client_id', 0);
            }
            else
            {
                $token = ORM::factory("AuthToken", $_COOKIE['login']);
                if($token->loaded() && $token->expiration_date < gmdate('Y-m-d H:i:s'))
                {
                    $token->delete();
                    setcookie('login', '', time() - 60, '/');
                }
                else
                {
                    $this->session->set('client_id', $token->client_id);
                }
            }
        }
        
        if($this->session->get('client_id') > 0)
        {
            $this->current_client = new Model_Customer($this->session->get('client_id'));
            if( ! $this->current_client->loaded())
            {
                $this->current_client = null;
            }
            $this->request->redirect('client/welcome/index');
        }
    }
    
    protected function logout()
    {
        // Invalidate "remember me" tokens
        $token = ORM::factory('AuthToken')->
                where('client_id', '=', Session::instance()->get('client_id'))->
                where('type', '=', 'login')->
                find();
        
        if($token->loaded())
        {
            $token->delete();
        }
        
        $this->session->set('client_id', 0);
        $this->current_user = 0;
        
        return true;
    }
}
