<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Containers_Registration extends Controller_Template {

    public $template = 'containers/registration';
    public $params = array();

    public function before()
    {
        //Required because we are extending Controller_Template
        parent::before();	
        $this->template->styles = array();
        $this->template->scripts = array();
        $this->params = explode('/',$this->request->param('params'));
        $this->template->title = 'Registro de nuevo usuario';

    }
    
    public function after()
    {		
        if ( $this->auto_render )
        {
                $action = $this->request->action();
                $controller =  $this->request->controller();

                //Build the styles array
                $css_file = 'media/css/controllers/admin/'.$controller.'/'.$action.'.css';
                $styles = array(
                        'media/css/blueprint/screen.css' => 'screen, projection',
                        'media/css/blueprint/print.css' => 'print',
                        'media/css/jquery-ui/smoothness/jquery-ui-1.8.16.custom.css' => 'all',
                        'media/css/dataTables/TableTools.css' => 'screen',
                        'media/css/dataTables/TableTools_JUI.css' => 'screen',
                        'media/css/jquery.dataTables.css' => 'screen',
                        'media/css/src/ie.css' => 'screen, projection',
                        'media/css/blueprint/ie.css' => 'print',
                        'media/css/styles.css' => 'screen',
                        'media/css/jquery.autocomplete.css' => 'screen',
                        'media/css/superfish.css' => 'screen',
                        'media/css/jquery-ui/jquery-ui.css' => 'screen',
                        'media/css/jquery.combobox.css' => 'screen',                   
                );

                //VALIDATING FILE
                if(file_exists($css_file) )
                {
                        $styles = array_merge( $styles, array($css_file=>'screen') );
                }

                //Build the scripts array
                $js_file = 'media/js/controller/admin/'.$controller.'/'.$action.'.js';
                $scripts = array(
                        //'media/js/jqueryLibrary/jquery-1.6.2.min.js',
                        'media/js/jqueryLibrary/jquery-1.8.2.js',
                        'media/js/jqueryLibrary/jquery-ui.js',
                        'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.js',
                        'media/js/jqueryLibrary/jquery-ui-1.9.0.custom.min.js',
                        'media/js/jqueryLibrary/jquery.combobox.js',
                        'media/js/jqueryLibrary/jquery-validation.js',
                        'media/js/jqueryLibrary/jquery.autocomplete.js',
                        'media/js/dataTables/jquery.dataTables.js',
                        'media/js/dataTables/TableTools.js',
                        'media/js/dataTables/ZeroClipboard.js',
                        'media/js/globalfunctions.js',
                        'media/js/menu/superfish.js' ,
                        'media/js/menu/hoverIntent.js',
                        'media/js/jquery.exptextarea.js',
                       
                );

                //VALIDATING FILE
                if(file_exists($js_file) )
                {
                    $scripts = array_merge( $scripts, array($js_file) );
                }


                //Set styles and scripts on the template (container). This can also be
                //done from any action method
                $this->template->styles = array_merge( $styles, $this->template->styles );
                $this->template->scripts = array_merge( $scripts, $this->template->scripts );

        }		

        //Required because we are extending Controller_Template
        parent::after();		
    }
}
