<?php defined('SYSPATH') or die('No direct script access.');

class Controller_Client_Login extends Controller_Containers_Client {
	
    public function action_login()
    {
        if($this->current_client)
            Request::current()->redirect('client/welcome/index');
			
        Session::instance()->delete('current_client');
        $view = View::factory('default/index');

        if (!empty($_POST))
        {
            $client = Model_Client::authenticate($_POST['username'], $_POST['password']);

            if ($client && $this->login($client->id)) 
            {
                if(isset($_POST['remember_me']))
                {
                    $this->remember_me();
                }
                
                $client_password_status = ORM::factory('Client', $client->id)->changed_password;
                    if($client_password_status == 'N')
                    {
                        $this->request->redirect('/client/login/changepassword');
                    }
                $this->request->redirect('/client/welcome/index');
            }
            else
            {
                $this->request->redirect('default/index');
            }
        }
             
        $this->template->content = $view;
    }
    
    public function action_changepassword()
    {
        if(!$this->current_client)
            Request::current()->redirect('client/');
       
        $view = View::factory('default/login/changepassword');
        $client = ORM::factory('client', $this->current_client);

        if (!empty($_POST))
        {
            $_POST['changed_password'] = 'Y';
                if($client->id == $_POST['id'])
                {
                    $client->changed_password = $_POST['changed_password'];
                    $client->password = $_POST['password'];
                    if($client->save())
                    {
                        FlashMessenger::factory()->set_message('success', Kohana::message('admin', 'client:changepassword:success'));                
                        $this->request->redirect('/client/');
                    }
                }
        }
         
        $view->set("client", $client);
        $this->template->set('content', $view);
    }
    
    protected function login($client_id)
    {
        $client = ORM::factory("Client", $client_id);
        if (!$client->loaded())
            return false;

        $this->session->set('client_id', $client->id);
        return true;
    }
    
    public function action_logout()
    {
        $this->logout();
        $this->request->redirect('/client/');
    }
	
    private function remember_me()
    {
        $expiration = date_create('+2 weeks UTC');

        $token = ORM::factory('AuthToken');
        $token->type = 'login';
        $token->client_id = Session::instance()->get('current_client');
        $token->expiration_dt = $expiration->format('Y-m-d H:i:s');
        $token->save();

        setcookie('login', $token->id, $expiration->format('U'),'/');
    }
	
    public function action_new_password()
    {
        ini_set('max_execution_time', 1800);
        ini_set('memory_limit', '3G');
        $token = $this->params[0];
        
        // skip this if we don't have a token
        if( ! $token) $this->request->redirect ('/client');
        
        $token = ORM::factory("AuthToken")->
                where('token', '=', $token)->
                find();
        
        $invalid_token = false;
        
        if( ! $token->loaded())
        {
            FlashMessenger::factory()->
                        set_message('error', 'Lo sentimos, el enlace que utiliz&oacute; para restaurar su contrase&ntilde;a no es v&aacute;lido.');
            $this->request->redirect('/client');
        }
        else if($token->loaded() && ($token->type != 'reset_password' || $token->expiration_dt < gmdate('Y-m-d H:i:s')))
        {
            $token->delete();
            FlashMessenger::factory()->
                        set_message('error', 'Lo sentimos, el enlace que utiliz&oacute; para restaurar su contrase&ntilde;a no es v&aacute;lido.');
            $this->request->redirect('/client');
        }
        
        if(count($_POST))
        {
            $client = Model::factory("client")->where('id', '=', $token->client_id)->find();
            $client->password = $_POST['password'];
            $client->save();

            $this->session->set('client_id', $client->id);

            FlashMessenger::factory()->
            set_message('success', 'Su contrase&ntilde;a se restableci&oacute; exitosamente.');

            $this->request->redirect('/client/');
        }
        
        $view = View::factory('default/login/new_password');
        $this->template->content = $view;
    }
    
    public function action_account() 
    {
        $view = View::factory('client/login/account');
        
        $client = ORM::factory('client', $this->current_client->id);

        if (!empty($_POST)) 
        {
            try 
            {
                //**************** CHANGE/CREATE PASSWORD SECTION
                if ($_POST['password'] == '_pass_flag_') 
                {
                    unset($_POST['password']);
                }
                if ($_POST['changed'] == 'yes') 
                {
                    $client->values($_POST);
                    $client->status = 'PENDING';
                    $client->save();
                
                    $new_categories = arr::get($this->request->post(), 'selBasicCatTo');
                    $old_categories = $client->categories->find_all()->as_array('id','id');

                    //remove previous categories
                    foreach ($old_categories as $c)
                    {
                        $category = new Model_Category($c);
                        $client->remove('categories',$category);
                    }

                    //add new categories    
                    foreach ($new_categories as $c)
                    {
                        $category = new Model_Category($c);
                        $client->add('categories',$category);
                    }
                    
                }
                
                $this->request->redirect('/client');
            } 
            catch (ORM_Validation_Exception $ex) 
            {
                foreach ($ex->errors('validation') as $error) 
                {
                    FlashMessenger::factory()->set_message('error', $error);
                }
            }
        }
        $all_categories = Model_Category::get_categories_list();
        $client_categories = $client->categories->find_all()->as_array('id','name');
        $non_client_categories = array_diff($all_categories, $client_categories);
        $view->set('non_client_categories', $non_client_categories);
        $view->set('client_categories', $client_categories);
        $view->set("current_date", date("Y-m-d"));
        $view->set('provinces',  Model_Globalfunctions::unshift_select_item(Model_Province::get_provinces_list()));
        $view->set('countries', Model_Globalfunctions::unshift_select_item(Model_Country::get_countries_list()));
        $view->set('company_types',  Model_Globalfunctions::unshift_select_item(Model_client::$company_types_values));
        $view->set('genders',  Model_Globalfunctions::unshift_select_item(Model_client::$gender_values));
        $view->set('document_types',  Model_Globalfunctions::unshift_select_item(Model_client::$document_type_values));
        $view->set('economic_activities',  Model_Globalfunctions::unshift_select_item(Model_Economicactivity::get_economicactivities_list()));
        $view->set("current_client", $this->current_client);
        $view->set("client", $client);
        $view->set("parishes", $client->parish->canton->parishes->find_all()->as_array('id','name'));
        $view->set("cantons", $client->parish->canton->province->cantons->find_all()->as_array('id','name'));
        $this->template->content = $view;

    }
    
}