<?php

class Model_Customer extends ORM {
    
    public $status_values = array('ACTIVE' => 'Activo', 'INACTIVE' => 'Inactivo','PENDING' => 'Pendiente');
    public $_table_name="customers";
    
    
     //..RELATIONSHIP WITH OTHER TABLES
   protected $_belongs_to = array(
     'city' => array(
         'model'       => 'City',
         'foreign_key' => 'city_id'
     ));
     
 
        
   public function __set($key, $val)
    {
            switch ($key)
            {
                case 'password':
                    parent::__set('password', md5($val));
                break;

                default:
                    parent::__set($key, $val);
            }
    }
    
    
    public static function authenticate($username, $password)
    {
        $customer = ORM::factory('Customer')->where('email', '=', $username)->find();

        if (!$customer->loaded())
        {
            FlashMessenger::factory()->set_message('error', 'El usuario ingresado no consta en el sistema.');
            return false;
        }
        
        if (md5($password) != $customer->password)
        {
            FlashMessenger::factory()->set_message('error', 'La contrase&ntilde;a ingresada es incorrecta.');
            return false;
        }            
        
        if ($customer->status == 'INACTIVE')
        {
            FlashMessenger::factory()->set_message('error', 'Usuario inactivo');
            return false;
        }

        return $customer;
    }
    
    public function filters() 
    {
        return array (
            'ruc' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'name' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'last_name' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'address' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'reference' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'phone' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'cellphone' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'email' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'password' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            )
        );
    }
    
    public function rules() 
    {
        return array (
            'ruc' => array (
                array('not_empty'),
            ),
            'city_id' => array (
                array('not_empty'),
            ),
            'name' => array (
                array('not_empty'),
            ),
            'last_name' => array (
                array('not_empty'),
            ),
            'address' => array (
                array('not_empty'),
            ),
            'phone' => array (
                array('not_empty'),
               
            ),
            'cellphone' => array (
                array('not_empty'),
            ),
            'email' => array (
                array('not_empty'),
            ),
            'password' => array (
                array('not_empty'),
            )
            
        );
    }
    
    
    
}


?>