<?php

class Model_Profile extends ORM {

    public $status_values = array('ACTIVE' => 'Activo', 'INACTIVE' => 'Inactivo');
    public $_table_name="profiles";
    
    protected $_has_many = array(
        'users' => array(),
        'actions' => array('through' => 'profile_actions'),
    );
    
    public function get_profile_action($parent_id,$profile_id)
    {
            $sql= "SELECT  *
                    FROM profile_actions pa
                    JOIN actions a ON a.id = pa.action_id
                    WHERE profile_id = :profile_id";         
            if($parent_id)
               $sql.=  " AND a.parent_id = :parent_id";
            elseif($parent_id===NULL)
               $sql.=  " AND a.parent_id IS NULL";
            
            $query = DB::query(Database::SELECT, $sql);
           
            $query->param(":profile_id", $profile_id);
            $query->param(":parent_id", $parent_id);
			
            $result = $query->execute()->as_array();
            if ($result)
            {
               return $result;
            }
            else
            {
               return false;
            }	
        }
        
    public function filters() 
    {
        return array (
            'name' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            )
        );
    }
	
    public function rules() 
    {
        return array (
            'name' => array (
                array('not_empty'),
            )
        );
    }
}

?>

