<?php


class Model_User extends ORM {

    public $status_values = array('ACTIVE' => 'Activo', 'INACTIVE' => 'Inactivo');
    public $_table_name="users";


    //..RELATIONSHIP WITH OTHER TABLES
    protected $_belongs_to = array(
     'profile' => array(
         'model'       => 'Profile',
         'foreign_key' => 'profile_id'
     ),
    );
	
    
//    protected $_has_many = array(
//        'processes' => array(
//            'model' => 'Process'
//        )
//    ); 
    
    public static $admin_allowed_actions = array(
//        'admin/welcome/index',
        'admin/user/acount',
        'admin/login/login',
        'admin/login/logout',
//		'admin/question/load_answer',
//		'admin/clarification/index',
//		'admin/question/index',
//		'admin/provider/providers',
//		'admin/parameter/update',
//		'admin/process/pdf',
    );
    
	
    public function __set($key, $val) {
            switch ($key) {
                    case 'password':
                            parent::__set('password', md5($val));
                            break;

                    default:
                            parent::__set($key, $val);
            }
    }

    public static function authenticate($username, $password)
    {
        $user = ORM::factory('User')->where('username', '=', $username)->find();

        if (!$user->loaded())
        {
            FlashMessenger::factory()->set_message('error', 'El usuario ingresado no consta en el sistema.');
            return false;
        }

        if ($user->status != 'ACTIVE')
        {
            FlashMessenger::factory()->set_message('error', 'Para usar el sistema, su cuenta debe estar activa.');
            return false;
        }
        
        if ($user->profile->status != 'ACTIVE')
        {
            FlashMessenger::factory()->set_message('error', 'Su perfil de usuario ha sido desactivado. Cont&aacute;ctese con el administrador');
            return false;
        }

        if (md5($password) != $user->password)
        {
            FlashMessenger::factory()->set_message('error', 'La contrase&ntilde;a ingresada es incorrecta.');
            return false;
        }

        return $user;
    }
    
    /**
    * Verifies if a User has access permission to the requested url
    * @param (string) $path
    * @return (boolean)
    */
    public function has_access_permission( $dir, $controller, $action , $allowed, $params)
    {
        if($controller == 'user' || $controller == 'profile')
            if($params[0] == '1')
                return FALSE;
        if( in_array( "{$dir}/{$controller}/{$action}", $allowed ) )
            return TRUE;

        $authorized = false;
        
        //load the action if exists into allowed_actions
        $allowed_actions = ORM::factory("Allowedactions")
                        ->with('action')
                        ->where("url", '=', "{$dir}/{$controller}/{$action}")->find();
		
        //check if the action is part of the allowed actions for a certain action			
        if($allowed_actions->loaded()){
                $authorized  = true;
        }		
        
        //load the action if exists into profile_actions
        $profile_action = ORM::factory("ProfileAction")->
                        with("action")->
                        where("profile_id", "=", $this->profile->id)->
                        where("link", "=", "{$dir}/{$controller}/{$action}")->find();
		
        //check if the action is part of the profile_actions	
        if($profile_action->action->loaded()){
            if($params[0] && $action == 'create')
            {
                 $profile_action_update = ORM::factory("ProfileAction")->
                        with("action")->
                        where("profile_id", "=", $this->profile->id)->
                        where("link", "=", "{$dir}/{$controller}/update")->find();
                        if($profile_action_update->action->loaded())
                            $authorized = true;
                        else 
                           $authorized = false;                     
            }
            else
                $authorized  = true;
        }
        else
        {
            //check if the called action is for updating rows
            if($action == 'create' && $params[0])
            {
                //verify if that profile is able to update rows
                $action = 'update';
                $profile_action = ORM::factory("ProfileAction")->
                        with("action")->
                        where("profile_id", "=", $this->profile->id)->
                        where("link", "=", "{$dir}/{$controller}/{$action}")->find();
                //give permissions only to update a row, not to create
                if($profile_action->action->loaded())
                    $authorized  = true;
            }
        }
		//return boolean with true or false to give permission
        return $authorized;
    }
    
     public function filters() 
    {
        return array (
            'username' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'password' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'name' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'last_name' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            ),
            'email' => array (
                array('trim'),
                array('strip_tags'),
                array('mysql_real_escape_string')
            )
        );
    }
	
    public function rules() 
    {
        return array (
            'username' => array (
                array('not_empty'),
            ),
            'password' => array (
                array('not_empty'),
            ),
            'name' => array (
                array('not_empty'),
            ),
            'email' => array (
                array('not_empty'),
                array('email'),
            ),
            'last_name' => array (
                array('not_empty'),
            )
        );
    }
    
}

?>
