<?php defined('SYSPATH') or die('No direct script access.');?>
<hr style="width: 100%;margin-left: 3px;">
<div class="prepend-2 span-20 append-2 last">
    <h2 class="center line" style="color: #9E1D29;">Administraci&oacute;n de &Oacute;rdenes</h2>


    <div class="span-20 last line content_area">
        <?php if(count($orders)>0): ?>
            <table id="table-orders">
                <thead>
                    <tr>
						<th>N&uacute;mero</th>
						<th>Fecha</th>
						<th>Estado</th>
                                                <th># Pago</th>
                                                <th>Total</th>
                                                <th>Acciones</th>
						
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($orders as $order): ?>
                    <tr>
                        <td><?php printf("%07d", $order->id); ?></td>
                        <td><?php echo $order->date; ?></td>
                        <td><?php echo $status_values[$order->status]; ?></td>
                        <td><?php echo $order->payment_number; ?></td>
                        <td><?php echo $order->total; ?></td>
                        <td class="span-2">
                             <?php if($order->status=='ORDERED'): ?> 
                            <?php echo HTML::anchor("#","Cancelar", array('id'=>'cancel_'.$order->id)); ?>
                                    |
                            <?php endif; ?>
                            <?php if($order->status=='PAYED' && $current_user->profile->has('actions', $action_invoice)): ?> 
                                    <?php echo HTML::anchor("admin/order/invoice/" . $order->id, "Finalizar"); ?> 
                                    |
                            <?php endif; ?>
                            <?php if($order->status=='SHIPPED' && $current_user->profile->has('actions', $action_invoice)): ?> 
                            <?php echo HTML::anchor("admin/order/invoice/" . $order->id, "Ver Factura"); ?> 
                                    |
                            <?php endif; ?>       
                            <?php echo HTML::anchor("admin/order/detail/" . $order->id, "Ver Detalle"); ?>   
                        </td>
                    </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        <?php else: ?>
            <div class="prepend-5 span-10 append-5 line last center">
                <div class="span-10 line last notice">
                        <?php echo Kohana::message('admin', 'order:index:empty'); ?>
                </div>
            </div>
        <?php endif; ?>
    </div>
</div>
<script type="text/javascript" >
    $(document).ready(function() {
	if($('#table-orders').length>0){        
        $('#table-orders').dataTable( {
            "bPaginate": true,
                        "bLengthChange": true,
            "bInfo": true,
            "sPaginationType": "full_numbers",
            "oLanguage": {
                "oPaginate": {
                                "sFirst": "Primera",
                                "sLast": "&Uacute;ltima",
                                "sNext": "Siguiente",
                                "sPrevious": "Anterior"
                },
                "sZeroRecords": "No se encontraron resultados",
                "sInfo": "_START_ - _END_ de _TOTAL_",
                "sInfoEmpty": "0 - 0 de 0",
                "sInfoFiltered": "(de _MAX_ en total)",
                "sSearch": "Buscar:",
                "sProcessing": "Filtrando..",
                "sLengthMenu": "Mostrar _MENU_ registros"
            },
            "aoColumns": [
                        {"sWidth":"15%", "bSortable":true},
                        {"sWidth":"10%", "bSortable":true},
                        {"sWidth":"15%", "bSortable":true},
                        {"sWidth":"10%", "bSortable":true},
                        {"sWidth":"15%", "bSortable":true},
                        {"sWidth":"35%", "bSortable":false}
                    ],
                    "aLengthMenu": [[20, 30, 40, 50, -1], [20, 30, 40, 50, "Todos"]],
                "iDisplayLength" : 20
        });	
    }

    $('[id^="cancel_"]').live('click',function(){
        show_ajax_loader();
        var answer = confirm("¿Está seguro de que desea cancelar esta compra? Recuerde que una vez cancelada no podrá volver atrás.")
        if (answer){				
            $.ajax({
                url: document_root+'admin/order/cancel',
                type: "post",
                dataType: 'json',
                data: {						
                    id: this.id.replace("cancel_","")
                },
                success: function(data){
                    if(data['cancel']){
                        window.location = document_root+"admin/order/index"
                        hide_ajax_loader();
                    }
                }
            });
        }else
            hide_ajax_loader();
    });	

});
</script>


