<?php defined('SYSPATH') or die('No direct script access.');?>

<div class="prepend-2 span-20 append-2 last">
    <h2 class="center line">Administraci&oacute;n de Productos</h2>


    <div class="span-20 last line content_area">
        <?php if($current_user->profile->has('actions', $action_create)): ?>
        <div class="span-20 last center">
		<?php echo HTML::anchor('admin/product/create', 'Nuevo Producto'); ?>
	</div>
        <?php endif; ?>
        <?php if(count($products)>0): ?>
            <table id="table-products">
                <thead>
                    <tr>
						<th>Código</th>
						<th>Nombre</th>
						<th>Descripci&oacuten</th>
                                                <th>P.C.</th>
                                                <th>P.V.P.</th>
                                                <th>Cantidad</th>
						<th>Tipo</th>
                                                <th>Acciones</th>
						
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($products as $product): ?>
                    <tr>
                        <td><?php echo $product->code; ?></td>
                        <td><?php echo $product->name; ?></td>
                        <td><?php echo $product->description; ?></td>
                        <td><?php echo $product->buy_price; ?></td>
                        <td><?php echo $product->sell_price; ?></td>
                        <td><?php echo $product->stock; ?></td>
                        <td><?php echo $type_values[$product->type]; ?></td>
                        <td class="span-2">
                             <?php if($current_user->profile->has('actions', $action_update)): ?> 
                                <?php echo HTML::anchor("admin/product/update/" . $product->id, "Actualizar"); ?>
                                 |
                               <?php echo HTML::anchor("#", "Eliminar", array('id'=>'delete_'.$product->id)); ?>							
                             <?php endif; ?>
                        </td>
                    </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        <?php else: ?>
            <div class="prepend-5 span-10 append-5 line last center">
                <div class="span-10 line last notice">
                        <?php echo Kohana::message('admin', 'product:index:empty'); ?>
                </div>
            </div>
        <?php endif; ?>
    </div>
</div>
<script type="text/javascript" >
    $(document).ready(function() {
	if($('#table-products').length>0){        
        $('#table-products').dataTable( {
            "bPaginate": true,
                        "bLengthChange": true,
            "bInfo": true,
            "sPaginationType": "full_numbers",
            "oLanguage": {
                "oPaginate": {
                                "sFirst": "Primera",
                                "sLast": "&Uacute;ltima",
                                "sNext": "Siguiente",
                                "sPrevious": "Anterior"
                },
                "sZeroRecords": "No se encontraron resultados",
                "sInfo": "_START_ - _END_ de _TOTAL_",
                "sInfoEmpty": "0 - 0 de 0",
                "sInfoFiltered": "(de _MAX_ en total)",
                "sSearch": "Buscar:",
                "sProcessing": "Filtrando..",
                "sLengthMenu": "Mostrar _MENU_ registros"
            },
            "aoColumns": [
                        {"sWidth":"10%", "bSortable":true},
                        {"sWidth":"15%", "bSortable":true},
                        {"sWidth":"25%", "bSortable":true},
                        {"sWidth":"5%", "bSortable":true},
                        {"sWidth":"5%", "bSortable":true},
                        {"sWidth":"8%", "bSortable":true},
                        {"sWidth":"10%", "bSortable":true},
                        {"sWidth":"22%", "bSortable":false}
                    ],
                    "aLengthMenu": [[20, 30, 40, 50, -1], [20, 30, 40, 50, "Todos"]],
                "iDisplayLength" : 20
        });	
    }

    $('[id^="delete_"]').live('click',function(){
        show_ajax_loader();
        var answer = confirm("Desea eliminar el Producto?")
        if (answer){				
            $.ajax({
                url: document_root+'admin/product/delete',
                type: "post",
                dataType: 'json',
                data: {						
                    id: this.id.replace("delete_","")
                },
                success: function(data){
                    if(data['delete']){
                        window.location = document_root+"admin/product/"
                        hide_ajax_loader();
                    }
                }
            });
        }else
            hide_ajax_loader();
    });	

});
</script>


