<?php defined('SYSPATH') or die('No direct script access.');?>

<div class="prepend-2 span-20 append-2 last">
    <h2 class="center line">Administraci&oacute;n de Proveedores</h2>


    <div class="span-20 last line content_area">
        <?php if($current_user->profile->has('actions', $action_create)): ?>
        <div class="span-20 last center">
		<?php echo HTML::anchor('admin/provider/create', 'Nuevo Proveedor'); ?>
	</div>
        <?php endif; ?>
        <?php if(count($providers)>0): ?>
            <table id="table-providers">
                <thead>
                    <tr>
						<th>Nombres</th>
						<th>RUC</th>
						<th>Tel&eacute;fono</th>
						<th>Email</th>
						<th>Estado</th>
						<th>Acciones</th>
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($providers as $provider): ?>
                    <tr>
                        <td><?php echo $provider->name; ?></td>
                        <td><?php echo $provider->ruc ?></td>
                        <td><?php echo $provider->phone; ?></td>
                        <td><?php echo $provider->email; ?></td>
                        <td class="span-2"><?php echo $status_values[$provider->status]; ?></td>
                        <td class="span-2">
                            <?php if($current_user->profile->has('actions', $action_update)): ?>
                                <?php echo HTML::anchor("admin/provider/update/" . $provider->id, "Actualizar"); ?> 
                                    |
                                <?php $question_opt = $provider->status=='ACTIVE'? "Desactivar" : "Activar"; ?>
                                <?php echo HTML::anchor("#", $question_opt, array('id'=>'deactivate_'.$provider->id, 'opt'=>$question_opt)); ?>							
                            <?php endif; ?>
                        </td>
                    </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        <?php else: ?>
            <div class="prepend-5 span-10 append-5 line last center">
                <div class="span-10 line last notice">
                        <?php echo Kohana::message('admin', 'provider:index:empty'); ?>
                </div>
            </div>
        <?php endif; ?>
    </div>
</div>
<script type="text/javascript" >
    $(document).ready(function() {
	if($('#table-providers').length>0){        
        $('#table-providers').dataTable( {
            "bPaginate": true,
                        "bLengthChange": true,
            "bInfo": true,
            "sPaginationType": "full_numbers",
            "oLanguage": {
                "oPaginate": {
                                "sFirst": "Primera",
                                "sLast": "&Uacute;ltima",
                                "sNext": "Siguiente",
                                "sPrevious": "Anterior"
                },
                "sZeroRecords": "No se encontraron resultados",
                "sInfo": "_START_ - _END_ de _TOTAL_",
                "sInfoEmpty": "0 - 0 de 0",
                "sInfoFiltered": "(de _MAX_ en total)",
                "sSearch": "Buscar:",
                "sProcessing": "Filtrando..",
                "sLengthMenu": "Mostrar _MENU_ registros"
            },
            "aoColumns": [
                        {"sWidth":"30%", "bSortable":true},
                        {"sWidth":"10%", "bSortable":false},
                        {"sWidth":"10%", "bSortable":true},
                        {"sWidth":"15%", "bSortable":true},
                        {"sWidth":"10%", "bSortable":true},
                        {"sWidth":"25%", "bSortable":false}
                    ],
                    "aLengthMenu": [[20, 30, 40, 50, -1], [20, 30, 40, 50, "Todos"]],
                "iDisplayLength" : 20
        });	
    }

    $('[id^="deactivate_"]').live('click',function(){
        show_ajax_loader();
        var answer = confirm("Desea "+$(this).attr('opt')+" el Proveedor?")
        if (answer){				
            $.ajax({
                url: document_root+'admin/provider/deactivate',
                type: "post",
                dataType: 'json',
                data: {						
                    id: this.id.replace("deactivate_","")
                },
                success: function(data){
                    if(data['saved']){
                        window.location = document_root+"admin/provider/"
                        hide_ajax_loader();
                    }
                }
            });
        }else
            hide_ajax_loader();
    });	

});
</script>


