<?php defined('SYSPATH') or die('No direct script access.');?>

<div class="prepend-2 span-20 append-2 last">
    <h2 class="center line">Administraci&oacute;n de Compras</h2>


    <div class="span-20 last line content_area">
        <?php if($current_user->profile->has('actions', $action_create)): ?>
        <div class="span-20 last line center">
		<?php echo HTML::anchor('admin/purchase/create', 'Nueva Compra'); ?>
	</div>
        <?php endif; ?>
        <?php if(count($purchases)>0): ?>
            <table id="table-purchases">
                <thead>
                    <tr>
						<th>Proveedor</th>
						<th>Fecha</th>
						<th>N&uacutemero Factura</th>
                                                <th>Total</th>
                                                <th>Acciones</th>
						
                    </tr>
                </thead>
                <tbody>
                    <?php foreach ($purchases as $purchase): ?>
                    <tr>
                        <td><?php echo $purchase->provider->name; ?></td>
                        <td><?php echo $purchase->date; ?></td>
                        <td><?php echo $purchase->number_invoice; ?></td>
                        <td><?php echo $purchase->total; ?></td>
                        <td class="span-2">
                             <?php if($current_user->profile->has('actions', $action_delete)): ?> 
                             <?php echo HTML::anchor("admin/purchase/update/" . $purchase->id, "Actualizar"); ?> 
                                    |
                             <?php echo HTML::anchor("#","Eliminar", array('id'=>'delete_'.$purchase->id)); ?>							
                             <?php endif; ?>
                        </td>
                    </tr>
                    <?php endforeach; ?>
                </tbody>
            </table>
        <?php else: ?>
            <div class="prepend-5 span-10 append-5 line last center">
                <div class="span-10 line last notice">
                        <?php echo Kohana::message('admin', 'purchase:index:empty'); ?>
                </div>
            </div>
        <?php endif; ?>
    </div>
</div>
<script type="text/javascript" >
    $(document).ready(function() {
	if($('#table-purchase').length>0){        
        $('#table-purchase').dataTable( {
            "bPaginate": true,
                        "bLengthChange": true,
            "bInfo": true,
            "sPaginationType": "full_numbers",
            "oLanguage": {
                "oPaginate": {
                                "sFirst": "Primera",
                                "sLast": "&Uacute;ltima",
                                "sNext": "Siguiente",
                                "sPrevious": "Anterior"
                },
                "sZeroRecords": "No se encontraron resultados",
                "sInfo": "_START_ - _END_ de _TOTAL_",
                "sInfoEmpty": "0 - 0 de 0",
                "sInfoFiltered": "(de _MAX_ en total)",
                "sSearch": "Buscar:",
                "sProcessing": "Filtrando..",
                "sLengthMenu": "Mostrar _MENU_ registros"
            },
            "aoColumns": [
                        {"sWidth":"20%", "bSortable":true},
                        {"sWidth":"20%", "bSortable":true},
                        {"sWidth":"20%", "bSortable":true},
                        {"sWidth":"20%", "bSortable":true},
                        {"sWidth":"20%", "bSortable":false}
                    ],
                    "aLengthMenu": [[20, 30, 40, 50, -1], [20, 30, 40, 50, "Todos"]],
                "iDisplayLength" : 20
        });	
    }

    $('[id^="delete_"]').live('click',function(){
        show_ajax_loader();
        var answer = confirm("Desea eliminar la Compra?")
        if (answer){				
            $.ajax({
                url: document_root+'admin/purchase/delete',
                type: "post",
                dataType: 'json',
                data: {						
                    id: this.id.replace("delete_","")
                },
                success: function(data){
                    if(data['delete']){
                        window.location = document_root+"admin/purchase/"
                        hide_ajax_loader();
                    }
                }
            });
        }else
            hide_ajax_loader();
    });	

});
</script>


