
<!doctype html>
<html xmlns="https://www.w3.org/1999/xhtml"
      prefix="og: https://ogp.me/ns#"
      lang="<?php echo I18n::$lang ?>">
    <head>
        <title><?php echo $title ?></title>
        <link rel="icon" type="image/png" href='<?php echo URL::site('/favicon.png')?>' />
        <?php foreach ($styles as $file => $type) echo HTML::style($file, array('media' => $type)), PHP_EOL ?>
        <?php foreach ($scripts as $file) echo HTML::script($file), PHP_EOL ?>    
        <script type="text/javascript">
                var document_root = '<?php echo Url::site();?>';
        </script>        
        <?php echo HTML::script('media/js/easyquery.js') ?>
    </head>
    <body>
<div class="container">
    <div style="display: none;" id="spinner">
        <div id="ajax_loader"></div>
        <div class="ajax_loader_text">Cargando...</div>
    </div>
    <header id="header">
        <div class="span-24">
            <a href=" <?php echo URL::site('client/welcome/index')  ?>" class="span-7">
                <div id="main_banner">
                </div>
            </a>
            <div class="span-10"id="finder" style="margin-top:30px;">
                <?php echo Form::open('account/index', array('id' => 'search_form')); ?>  
                <?php echo Form::input('description', NULL, array('id' => 'description','class' => 'service-search span-7','style' => 'margin-top:5px; width: 270px !important;','placeholder'=>'Ingresa el código, marca de auto o producto')); ?>
                <?php echo Form::button('button_search','Buscar', array('id' => 'button_search','class' => 'search-button span-2 last','style' => 'margin-left:5px !important;margin-top:0px !important;')) ;?>
                <div class="span-10">
                    <?php echo Form::label("search_radio", "Todo", array('class'=>'left')); ?>
                    <?php echo Form::radio("search_radio", 'All', TRUE,array('class'=>'left','style'=>'margin-right:20px;')); ?> 
                    <?php echo Form::label("search_radio", "Bandas", array('class'=>'left')); ?>
                    <?php echo Form::radio("search_radio", 'Band', FALSE,array('class'=>'left','style'=>'margin-right:20px;')); ?>  
                    <?php echo Form::label("search_radio", "Pastillas de Freno", array('class'=>'left')); ?>
                    <?php echo Form::radio("search_radio", 'Brakepad', FALSE,array('class'=>'left')); ?>  
                </div>
                <?php echo Form::close(); ?> 
            </div>
            <div class="span-7 right last" style="margin-top:36px;">
                <a href="#contact" id="contact_button">Contacto</a>
                |
                <a href="<?php echo URL::site('registration/index')  ?>">Regístrate</a>
                |
                <a href="#login" id="login_button">Iniciar Sesión</a>
            </div>
            <div class="span-24 last center" style="margin-top:10px;font-size:15px;">
                <label> Sistema de ventas en l&iacute;nea</label> 
            </div>
            
        </div>  
    </header>
    <section id="content">
        <div class="prepend-2 span-20 append-2 last line">
            <?php FlashMessenger::factory()->get_messages(); ?>
        </div>
        <?php echo $content; ?>
        <script type="text/javascript" >
                $(document).ready(function(){
                    show_ajax_loader();
                    window.onload = function(){
                        hide_ajax_loader();
                    }
                });
        </script>
    </section>

    <footer class="span-24 last footer" align="center" style="text-align:center;">
        <div style="margin-right:20px;padding-top:5px;">
            <label style="color:white;font-size:19px;font-weight:normal;">Importadora D&aacute;vila</label>
        </div>
        <div class="span-24 last center">
                        Gerardo Chiriboga N52-128 y Capit&aacute;n Ram&oacute;n Borja (Kennedy) -
                        Telefax: 2416071 / 2814025 -
                        Cel: 0998507601 <br>
                        Email: importadoradavila@hotmail.com<br>
                        Quito – Ecuador

                    </div>
    </footer>
</div>
<div style="display:none">
    <div  id="login" class="span-14">
            <div style="font-weight: normal;font-size:18px;text-align: center;margin-bottom: 15px;font-size:16px;line-height: 20px;padding-left: 8px;">Iniciar Sesión</div>
            <div style="width: 90%;padding-left: 5%;padding-right: 5%;" align="center">
                <?php echo Form::open(NULL, array('id' => 'login_form', 'class' => 'span-12'));?>
                <div class="span-2"> <?php echo Form::label(NULL,'E-mail: ', array('class' => 'right'));?> </div> 
                <div class="span-10 last line"><?php echo Form::input('username', NULL, array('id' => 'username','class' => 'user-pass span-10','tabindex'=>'1')); ?> </div> 
                <div class="span-2"> <?php echo Form::label(NULL,'Contrase&ntilde;a: ', array('class' => 'right'));?> </div> 
                <div class="span-10 last line"> <?php echo Form::password('password', NULL, array('id' => 'password','class' => 'user-pass span-10','tabindex'=>'2')); ?></div>
                <div style="float:none;"> <?php echo Form::submit('submit', 'Inicia sesión', array('id' => 'submit','class' => 'button-login','type' => 'submit','tabindex'=>'3')) ; ?></div>  <br> 
                <div style="width: 100%">
                    <?php echo HTML::anchor('#forgot_password_box','Olvid&eacute; mi contrase&ntilde;a', array('id' => 'forgot_password','class' => 'forgot-password')); ?>
                </div>
                <?php echo Form::close();?>
            </div> 
    </div>
</div>
        
<div style="display:none">
    <div  id="contact" class="span-14">
            <div style="font-weight: normal;font-size:18px;text-align: center;margin-bottom: 15px;font-size:16px;line-height: 20px;padding-left: 8px;">Contacto</div>
            <div style="width: 90%;padding-left: 5%;padding-right: 5%;" align="center">
                <?php echo Form::open(NULL, array('id' => 'contact_form', 'class' => 'span-12'));?>
                <div class="span-2"> <?php echo Form::label(NULL,'E-mail: ', array('class' => 'right'));?> </div> 
                <div class="span-10 last line"><?php echo Form::input('email', NULL, array('id' => 'email','class' => 'span-10')); ?> </div> 
                <div class="span-2"> <?php echo Form::label(NULL,'Mensaje: ', array('class' => 'right'));?> </div> 
                <div class="span-10 last line"> <?php echo Form::textarea('text', NULL, array('id' => 'text','class' => 'span-10','style'=>'width:390px;')); ?></div>
                <div style="float:none;"> <?php echo Form::submit('message_send', 'Enviar', array('id' => 'message_send','class' => 'button-login','type' => 'submit')) ; ?></div>  <br> 
                
                <?php echo Form::close();?>
            </div> 
    </div>
</div>
        
    </body>
</html>
<script type="text/javascript" >

    $(document).ready(function() {

    $("a#login_button").fancybox({
		'hideOnContentClick': false,            
                'titleShow':true,
              'enableEscapeButton':true,
                'onClosed'	:	function() {
                    $("#username").val('');
                    $("#password").val('');
                }
	});
        
    $("a#contact_button").fancybox({
		'hideOnContentClick': false,            
                'titleShow':true,
              'enableEscapeButton':true,
                'onClosed'	:	function() {
                    $("#email").val('');
                    $("#message").val('');
                }
	});
        
        $("#login_form").validate({
            onfocusout: false,
            onkeyup: false,
            wrapper: "ol",
            rules: {
                username:{
                    required:true
                },
                password:{
                    required:true
                }
            }
        });
        
        $("#contact_form").validate({
            onfocusout: false,
            onkeyup: false,
            wrapper: "ol",
            rules: {
                email:{
                    required:true
                },
                text:{
                    required:true
                }
            }
        });
        
        $('textarea').expandingTextArea();
      });
</script>